(function() {
    'use strict';
    class AutoPage extends Laya.Script {
        onAwake() {
            let View = this.owner;
            View.width = Laya.stage.width;
            View.height = Laya.stage.height
        }
    }
    class EventControl {
        constructor() {
            this.eventDispatcher = new Laya.EventDispatcher()
        }
        emit(InName, data = null) {
            return this.eventDispatcher.event(InName, [data])
        }
        on(InName, caller, listener, arg) {
            this.eventDispatcher.on(InName, caller, listener, arg)
        }
        once(InName, caller, listener, arg) {
            this.eventDispatcher.once(InName, caller, listener, arg)
        }
        off(InName, caller, listener) {
            this.eventDispatcher.off(InName, caller, listener)
        }
        offAll(caller) {
            this.eventDispatcher.offAllCaller(caller)
        }
    }
    var EventControl$1 = new EventControl();
    class _UIControl {
        constructor() {
            this.Views = []
        }
        ShowUI(_class, data) {
            let _index = UIControl.GetUIIndexFromViews(_class.NAME);
            let _view = UIControl.Views[_index];
            _class.DATA = data;
            if (!_view) {
                _view = new _class(data);
                UIControl.Views.push(_view)
            }
            _view.name = _class.NAME;
            Laya.stage.addChild(_view);
            _view.visible = true;
            if (_class.AUTO) {
                _view.addComponent(AutoPage)
            }
            return _view
        }
        HideUI(_class) {
            let _index = UIControl.GetUIIndexFromViews(_class.NAME);
            let _view = UIControl.Views[_index];
            if (_view) {
                Laya.stage.removeChild(_view);
                _view.visible = false
            }
        }
        RemoveUI(_class) {
            let _index = UIControl.GetUIIndexFromViews(_class.NAME);
            if (_index == -1) return;
            let _view = UIControl.Views[_index];
            if (_view) {
                _view.visible = false;
                _class.DATA = null;
                Laya.timer.clearAll(_view);
                Laya.stage.offAllCaller(_view);
                EventControl$1.offAll(_view);
                UIControl.Views.splice(_index, 1);
                Laya.timer.frameOnce(10, null, () => {
                    Laya.stage.removeChild(_view);
                    _view.destroy()
                })
            }
        }
        GetUI(_name) {
            let _index = UIControl.GetUIIndexFromViews(_name.name);
            let _view = UIControl.Views[_index];
            if (_view) {
                return _view
            } else {
                return null
            }
        }
        GetUIIndexFromViews(_names) {
            return UIControl.Views.findIndex((_ui) => {
                return _ui.name == _names
            })
        }
    }
    const UIControl = new _UIControl();
    var View = Laya.View;
    var Scene = Laya.Scene;
    var REG = Laya.ClassUtils.regClass;
    var ui;
    (function(ui) {
        var ViewSign;
        (function(ViewSign) {
            class View_SignUI extends View {
                constructor() {
                    super()
                }
                createChildren() {
                    super.createChildren();
                    this.loadScene("ViewSign/View_Sign")
                }
            }
            ViewSign.View_SignUI = View_SignUI;
            REG("ui.ViewSign.View_SignUI", View_SignUI)
        })(ViewSign = ui.ViewSign || (ui.ViewSign = {}))
    })(ui || (ui = {}));
    (function(ui) {
        class View_DrawUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_Draw")
            }
        }
        ui.View_DrawUI = View_DrawUI;
        REG("ui.View_DrawUI", View_DrawUI);
        class View_GameUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_Game")
            }
        }
        ui.View_GameUI = View_GameUI;
        REG("ui.View_GameUI", View_GameUI);
        class View_LaunchUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.createView(View_LaunchUI.uiView)
            }
        }
        View_LaunchUI.uiView = {
            "type": "View",
            "props": {
                "width": 750,
                "top": 0,
                "right": 0,
                "left": 0,
                "height": 1334,
                "bottom": 0
            },
            "compId": 2,
            "child": [{
                "type": "Label",
                "props": {
                    "y": 0,
                    "x": 0,
                    "top": 0,
                    "right": 0,
                    "left": 0,
                    "bottom": 0,
                    "bgColor": "#efefef"
                },
                "compId": 4
            }, {
                "type": "Label",
                "props": {
                    "text": window.isRussian ? "Загрузка..." : "加载中...",
                    "font": "Arial",
                    "fontSize": 72,
                    "bold": true,
                    "color": "#009900",
                    "centerY": 0,
                    "centerX": 0
                },
                "compId": 3
            }, {
                "type": "Script",
                "props": {
                    "y": 0,
                    "x": 0,
                    "runtime": "Code/GameCode/Engine.ts"
                },
                "compId": 5
            }],
            "animations": [{
                "nodes": [{
                    "target": 4,
                    "keyframes": {
                        "alpha": [{
                            "value": 0,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 4,
                            "key": "alpha",
                            "index": 0
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 4,
                            "key": "alpha",
                            "index": 30
                        }]
                    }
                }, {
                    "target": 3,
                    "keyframes": {
                        "scaleY": [{
                            "value": 0,
                            "tweenMethod": "elasticOut",
                            "tween": true,
                            "target": 3,
                            "key": "scaleY",
                            "index": 0
                        }, {
                            "value": 0,
                            "tweenMethod": "elasticOut",
                            "tween": true,
                            "target": 3,
                            "label": null,
                            "key": "scaleY",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 3,
                            "key": "scaleY",
                            "index": 90
                        }],
                        "scaleX": [{
                            "value": 0,
                            "tweenMethod": "elasticOut",
                            "tween": true,
                            "target": 3,
                            "key": "scaleX",
                            "index": 0
                        }, {
                            "value": 0,
                            "tweenMethod": "elasticOut",
                            "tween": true,
                            "target": 3,
                            "label": null,
                            "key": "scaleX",
                            "index": 30
                        }, {
                            "value": 1,
                            "tweenMethod": "linearNone",
                            "tween": true,
                            "target": 3,
                            "key": "scaleX",
                            "index": 90
                        }]
                    }
                }],
                "name": "ani1",
                "id": 1,
                "frameRate": 60,
                "action": 1
            }],
            "loadList": ["Launch/loading.png"],
            "loadList3D": []
        };
        ui.View_LaunchUI = View_LaunchUI;
        REG("ui.View_LaunchUI", View_LaunchUI);
        class View_LoadingUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_Loading")
            }
        }
        ui.View_LoadingUI = View_LoadingUI;
        REG("ui.View_LoadingUI", View_LoadingUI);
        class View_MainUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_Main")
            }
        }
        ui.View_MainUI = View_MainUI;
        REG("ui.View_MainUI", View_MainUI);
        class View_OverErrUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_OverErr")
            }
        }
        ui.View_OverErrUI = View_OverErrUI;
        REG("ui.View_OverErrUI", View_OverErrUI);
        class View_OverWinUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_OverWin")
            }
        }
        ui.View_OverWinUI = View_OverWinUI;
        REG("ui.View_OverWinUI", View_OverWinUI);
        class View_SettingUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_Setting")
            }
        }
        ui.View_SettingUI = View_SettingUI;
        REG("ui.View_SettingUI", View_SettingUI);
        class View_StoreUI extends View {
            constructor() {
                super()
            }
            createChildren() {
                super.createChildren();
                this.loadScene("View_Store")
            }
        }
        ui.View_StoreUI = View_StoreUI;
        REG("ui.View_StoreUI", View_StoreUI)
    })(ui || (ui = {}));
    class View_Launch extends ui.View_LaunchUI {
        onAwake() {
            console.log("lanuch")
        }
    }
    View_Launch.NAME = "View_Launch";
    View_Launch.AUTO = true;
    View_Launch.DATA = null;
    class AD_Virtual {
        constructor() {
            this.CanLog = true;
            this.CanWarn = true;
            this.CanError = true
        }
        Log(...data) {
            if (this.CanLog) {
                switch (data.length) {
                    case 1:
                        console.log(data[0]);
                        break;
                    case 2:
                        console.log(data[0], data[1]);
                        break;
                    case 3:
                        console.log(data[0], data[1], data[2]);
                        break;
                    case 4:
                        console.log(data[0], data[1], data[2], data[3]);
                        break;
                    case 5:
                        console.log(data[0], data[1], data[2], data[3], data[5]);
                        break;
                    default:
                        console.log(data)
                }
            }
        }
        Warn(...data) {
            if (this.CanWarn) {
                switch (data.length) {
                    case 1:
                        console.warn(data[0]);
                        break;
                    case 2:
                        console.warn(data[0], data[1]);
                        break;
                    case 3:
                        console.warn(data[0], data[1], data[2]);
                        break;
                    case 4:
                        console.warn(data[0], data[1], data[2], data[3]);
                        break;
                    case 5:
                        console.warn(data[0], data[1], data[2], data[3], data[5]);
                        break;
                    default:
                        console.warn(data)
                }
            }
        }
        Error(...data) {
            if (this.CanError) {
                switch (data.length) {
                    case 1:
                        console.error(data[0]);
                        break;
                    case 2:
                        console.error(data[0], data[1]);
                        break;
                    case 3:
                        console.error(data[0], data[1], data[2]);
                        break;
                    case 4:
                        console.error(data[0], data[1], data[2], data[3]);
                        break;
                    case 5:
                        console.error(data[0], data[1], data[2], data[3], data[5]);
                        break;
                    default:
                        console.error(data)
                }
            }
        }
    }
    AD_Virtual.Self = null;
    class NativeAdClass {
        constructor(_ad, _InterAd, _InterAdList) {
            this.adid = _ad;
            this.nativeAd = _InterAd;
            this.nativeData = _InterAdList
        }
    }
    var AdRes;
    (function(AdRes) {
        AdRes[AdRes["None"] = 0] = "None";
        AdRes[AdRes["Success"] = 1] = "Success";
        AdRes[AdRes["Version"] = 2] = "Version";
        AdRes[AdRes["Oppo_Sixty"] = 3] = "Oppo_Sixty"
    })(AdRes || (AdRes = {}));
    var AdType;
    (function(AdType) {
        AdType[AdType["None"] = 0] = "None";
        AdType[AdType["Custom"] = 5] = "Custom";
        AdType[AdType["Banner"] = 6] = "Banner";
        AdType[AdType["Interstitial"] = 7] = "Interstitial";
        AdType[AdType["GameBanner"] = 8] = "GameBanner";
        AdType[AdType["GamePortal"] = 9] = "GamePortal";
        AdType[AdType["GameDrawer"] = 10] = "GameDrawer"
    })(AdType || (AdType = {}));
    class AD_None extends AD_Virtual {
        constructor() {
            super();
            AD_Virtual.Self = this
        }
        InitAD() {}
        ClearShowAd(adType) {}
        HadAd(adType) {
            return false
        }
        GetNativeData() {}
        Preload_NativeAd(_id, onLoad, onError) {}
        LoadNativeAD(id, onLoad) {}
        OpenCustomAD(id, style, onLoad, onShow, onClose, onError) {}
        OpenInterstitial(id, onLoad, onShow, onClose, onError) {}
        OpenBanner(id, style, onLoad, onShow, onClose, onError) {}
        OpenVideo(adid, onLoad, onShow, onClose, onError) {}
        OpenGameBanner(id, top, left, orientation, onLoad, onShow, onClose, onError) {}
        OpenGamePortal(id, onLoad, onShow, onClose, onError) {}
        OpenGameDrawer(id, style, onShow, onError) {}
        AddToDesktop(onSuccess, onFail, onError, hadCreate) {}
        CanAddDesktop() {
            return false
        }
        HadAddDesktop(onSuccess, onError) {}
        GetSystemInfoSync2() {
            return 0
        }
    }
    class AD_oppo extends AD_Virtual {
        constructor() {
            super();
            this.sixty = false;
            this.ShowAd = AdType.None;
            this.PreLoadNativeData = null;
            this.preloadInter = 1000;
            this.loadArray = [];
            this.loading = false;
            this.mCustomAD = null;
            this.mGameBanner = null;
            this.mGamePortal = null;
            this.systemVersion = null;
            AD_Virtual.Self = this
        }
        InitAD() {
            AD_Virtual.Self.Log("oppo init ad");
            this.sixty = true
        }
        ClearShowAd(adType) {
            switch (adType) {
                case AdType.Banner:
                    this.mBanner && this.mBanner.hide();
                    this.mBanner && this.mBanner.destroy();
                    this.mBanner = null;
                    break;
                case AdType.GameBanner:
                    this.mGameBanner && this.mGameBanner.destroy();
                    this.mGameBanner = null;
                    break;
                case AdType.GameDrawer:
                    this.mGameDrawer && this.mGameDrawer.destroy();
                    this.mGameDrawer = null;
                    break;
                case AdType.GamePortal:
                    if (this.mGamePortal && this.mGamePortal.destroy) {
                        this.mGamePortal.destroy();
                        this.mGamePortal = null
                    }
                    break;
                case AdType.Custom:
                    this.mCustomAD && this.mCustomAD.hide();
                    this.mCustomAD && this.mCustomAD.destroy();
                    this.mCustomAD = null;
                    break;
                case AdType.Interstitial:
                    break
            }
        }
        HadAd(adType) {
            switch (adType) {
                case AdType.Banner:
                    return Boolean(this.mBanner);
                case AdType.GameBanner:
                    return Boolean(this.mGameBanner);
                case AdType.GameDrawer:
                    return Boolean(this.mGameDrawer);
                case AdType.GamePortal:
                    return Boolean(this.mGamePortal);
                case AdType.Custom:
                    return Boolean(this.mCustomAD);
                case AdType.Interstitial:
                    return false
            }
        }
        Reject() {
            this.mBanner && this.mBanner.hide();
            this.mBanner && this.mBanner.destroy();
            this.mBanner = null;
            this.mGameBanner && this.mGameBanner.destroy();
            this.mGameBanner = null;
            this.mGameDrawer && this.mGameDrawer.destroy();
            this.mGameDrawer = null;
            if (this.mGamePortal && this.mGamePortal.hide) {
                this.mGamePortal.hide();
                this.mGamePortal = null
            }
            this.mCustomAD && this.mCustomAD.hide();
            this.mCustomAD && this.mCustomAD.destroy();
            this.mCustomAD = null
        }
        GetNativeData() {
            if (this.PreLoadNativeData == null) return null;
            else {
                let temp = this.PreLoadNativeData;
                this.PreLoadNativeData = null;
                return temp
            }
        }
        Preload_NativeAd(_id, onLoad, onError) {
            if (!this.sixty) {
                return AdRes.Oppo_Sixty
            }
            this.LoadNativeAD(_id, (res) => {
                this.PreLoadNativeData = res;
                onLoad && onLoad(res)
            }, (err) => {
                AD_Virtual.Self.Log("预加载失败");
                onError && onError(err)
            })
        }
        LoopLoad() {
            if (this.loadArray.length == 0) {
                this.loading = false;
                return
            }
            let temp = this.loadArray.shift();
            this.loading = false;
            this.LoadNativeAD(temp.id, temp.onLoad, temp.onError)
        }
        LoadNativeAD(id, onLoad, onError) {
            if (this.loading) {
                if (this.loadArray.length >= 5) {
                    AD_Virtual.Self.Error("AD--->qg--->原生--->原生广告请求太频繁了 不予加载");
                    return
                }
                let temp = {
                    id: id,
                    onLoad: onLoad,
                    onError: onError,
                };
                this.loadArray.push(temp);
                return
            }
            if (this.PreLoadNativeData && this.PreLoadNativeData.adid == id) {
                this.PreLoadNativeData = null
            }
            this.Reject();
            let nativeAd = Laya.Browser.window.qg.createNativeAd({
                adUnitId: id,
            });
            nativeAd.onLoad(function(res) {
                nativeAd.offLoad();
                nativeAd.offError();
                var _ts = new NativeAdClass(id, nativeAd, res.adList);
                AD_Virtual.Self.Log("AD--->qg--->原生--->加载成功", id, nativeAd, res);
                onLoad && onLoad(_ts)
            });
            nativeAd.onError(function(err) {
                nativeAd.offLoad();
                nativeAd.offError();
                AD_Virtual.Self.Log("AD--->qg--->原生--->加载失败", err, id);
                onError && onError(err)
            });
            nativeAd.load();
            this.loading = true;
            Laya.timer.once(this.preloadInter, this, this.LoopLoad)
        }
        OpenCustomAD(id, style, onLoad, onShow, onClose, onError) {
            if (this.GetSystemInfoSync2() < 1092) {
                AD_Virtual.Self.Error("版本过低 不支持原生模板广告");
                return AdRes.Version
            }
            if (!Boolean(style) || style.length != 3) {
                AD_Virtual.Self.Error("参数检测错误 opencustomad style");
                return AdRes.None
            }
            if (!this.sixty) {
                return AdRes.Oppo_Sixty
            }
            if (this.mCustomAD == null) {
                this.Reject();
                let customAd = Laya.Browser.window.qg.createCustomAd({
                    adUnitId: id,
                    style: {
                        top: style[0],
                        left: style[1],
                        width: style[2],
                    }
                });
                let self = this;
                customAd.onLoad(() => {
                    AD_Virtual.Self.Log('customAd广告加载成功');
                    onLoad && onLoad();
                    customAd.offLoad()
                });
                customAd.onShow(() => {
                    AD_Virtual.Self.Log('customAd广告显示');
                    customAd.offShow();
                    onShow && onShow();
                    self.ShowAd = AdType.Custom
                });
                customAd.onHide(() => {
                    AD_Virtual.Self.Log('customAd广告隐藏');
                    customAd.offHide();
                    onClose && onClose();
                    customAd.destroy();
                    self.mCustomAD = null
                });
                customAd.show().then(() => {
                    AD_Virtual.Self.Log('show success');
                    self.mCustomAD = customAd
                }).catch((error) => {
                    AD_Virtual.Self.Log('show fail with:' + error.errCode + ',' + error.errMsg);
                    self.mCustomAD = null;
                    onError && onError(error)
                });
                return AdRes.Success
            }
            return AdRes.None
        }
        OpenInterstitial(id, onLoad, onShow, onClose, onError) {
            return AdRes.None
        }
        OpenBanner(id, style, onLoad, onShow, onClose, onError) {
            AD_Virtual.Self.Log("AD--->qg--->Banner--->加载");
            let bannerAd;
            if (style && style.length == 4) {
                bannerAd = Laya.Browser.window.qg.createBannerAd({
                    posId: id,
                    style: {
                        top: style[0],
                        left: style[1],
                        width: style[2],
                        height: style[3]
                    }
                })
            } else {
                bannerAd = Laya.Browser.window.qg.createBannerAd({
                    posId: id,
                })
            }
            this.Reject();
            let self = this;
            bannerAd.onError(err => {
                AD_Virtual.Self.Log("banner广告加载失败", err);
                onError && onError(err)
            });
            bannerAd.onLoad(function() {
                AD_Virtual.Self.Log('banner 广告加载成功');
                onLoad && onLoad()
            });
            bannerAd.show().then(() => {
                AD_Virtual.Self.Log('banner广告展示完成');
                onShow && onShow();
                self.ShowAd = AdType.Banner
            }).catch((err) => {
                AD_Virtual.Self.Log('banner广告展示失败', JSON.stringify(err));
                onError && onError(err)
            });
            bannerAd.onHide(() => {
                AD_Virtual.Self.Log("banner广告关闭");
                onClose && onClose()
            });
            this.mBanner = bannerAd
        }
        OpenVideo(adid, onLoad, onShow, onClose, onError) {
            const rewardedAd = Laya.Browser.window.qg.createRewardedVideoAd({
                posId: adid,
            });
            rewardedAd.onError(err => {
                AD_Virtual.Self.Log("激励视频广告加载失败", err);
                onError && onError()
            });
            rewardedAd.onLoad(function(res) {
                AD_Virtual.Self.Log('激励视频广告加载完成-onload触发', JSON.stringify(res));
                onLoad && onLoad(res);
                rewardedAd.show().then(() => {
                    AD_Virtual.Self.Log('激励视频广告展示完成');
                    onShow && onShow()
                }).catch((err) => {
                    AD_Virtual.Self.Log('激励视频广告展示失败', JSON.stringify(err));
                    onError && onError()
                })
            });
            let closeBack = false;
            rewardedAd.onClose(function(res) {
                if (closeBack) return;
                closeBack = true;
                AD_Virtual.Self.Log('视频广告关闭回调');
                onClose && onClose(res)
            });
            AD_Virtual.Self.Log("AD--->qg--->广告--->加载load");
            rewardedAd.load();
            return AdRes.Success
        }
        OpenGameBanner(id, top, left, orientation, onLoad, onShow, onClose, onError) {
            if (this.GetSystemInfoSync2() >= 1076) {
                let gameBannerAd;
                if (this.GetSystemInfoSync2() >= 1090) {
                    gameBannerAd = Laya.Browser.window.qg.createGameBannerAd({
                        adUnitId: id,
                        style: {
                            top: top,
                            left: left,
                            orientation: orientation,
                        }
                    })
                } else {
                    gameBannerAd = Laya.Browser.window.qg.createGameBannerAd({
                        adUnitId: id
                    })
                }
                this.Reject();
                let self = this;
                gameBannerAd.onShow(() => {
                    AD_Virtual.Self.Log('Gamebanner 广告显示');
                    onShow && onShow();
                    self.ShowAd = AdType.GameBanner
                });
                gameBannerAd.onLoad(function() {
                    AD_Virtual.Self.Log('互推盒子横幅广告加载成功');
                    onLoad && onLoad()
                });
                gameBannerAd.onError(function(err) {
                    AD_Virtual.Self.Log('互推盒子横幅广告错误', err);
                    onError && onError(err)
                });
                gameBannerAd.show().then(function() {
                    AD_Virtual.Self.Log('show success')
                }).catch(function(error) {
                    AD_Virtual.Self.Log('show fail with:' + error.errCode + ',' + error.errMsg);
                    onError && onError(error)
                });
                this.mGameBanner = gameBannerAd
            }
            AD_Virtual.Self.Error("版本过低 不支持互推横幅");
            return AdRes.Version
        }
        OpenGamePortal(id, onLoad, onShow, onClose, onError) {
            if (this.GetSystemInfoSync2() < 1076) {
                AD_Virtual.Self.Error("版本过低 不支持互推横幅");
                return AdRes.Version
            }
            let GamePortalAd = Laya.Browser.window.qg.createGamePortalAd({
                adUnitId: id
            });
            let self = this;
            GamePortalAd.load().then(function() {
                AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> load success');
                onLoad && onLoad();
                GamePortalAd.show().then(function() {
                    AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> show success');
                    onShow && onShow();
                    self.ShowAd = AdType.GamePortal
                }).catch(function(error) {
                    AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> show fail with:' + error.errCode + ',' + error.errMsg);
                    onError && onError(error)
                })
            }).catch(function(error) {
                AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> load fail with:' + error.errCode + ',' + error.errMsg);
                onError && onError(error)
            });
            GamePortalAd.onClose(function() {
                AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> 互推盒子九宫格广告关闭');
                onClose && onClose();
                GamePortalAd.offClose();
                self.mGamePortal = null;
                GamePortalAd.destroy().then(function() {
                    AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> destroy success')
                }).catch(function(error) {
                    AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> destroy fail with:' + error.errCode + ',' + error.errMsg)
                })
            });
            this.mGamePortal = GamePortalAd
        }
        OpenGameDrawer(id, style, onShow, onError) {
            if (this.GetSystemInfoSync2() >= 1090) {
                this.Reject();
                let self = this;
                var GameDrawerAd = Laya.Browser.window.qg.createGameDrawerAd({
                    adUnitId: id,
                    style: {
                        top: style[0]
                    }
                });
                GameDrawerAd.onShow(function() {
                    AD_Virtual.Self.Log('drawer 广告显示');
                    onShow && onShow()
                });
                GameDrawerAd.onError(function(err) {
                    AD_Virtual.Self.Log(err);
                    onError && onError(err)
                });
                GameDrawerAd.show().then(function() {
                    AD_Virtual.Self.Log('show success');
                    self.ShowAd = AdType.GameDrawer
                }).catch(function(error) {
                    AD_Virtual.Self.Log('show fail with:' + error.errCode + ',' + error.errMsg);
                    onError && onError(error)
                });
                this.mGameDrawer = GameDrawerAd
            } else {
                AD_Virtual.Self.Log('快应用平台版本号低于1090，暂不支持互推盒子相关 API');
                return AdRes.Version
            }
        }
        AddToDesktop(onSuccess, onFail, onError, hadCreate) {
            if (this.GetSystemInfoSync2() < 1044) {
                AD_Virtual.Self.Error("版本过低 不支持添加到桌面");
                onError && onError(null)
            }
            Laya.Browser.window.qg.hasShortcutInstalled({
                success: function(res) {
                    if (res == false) {
                        AD_Virtual.Self.Log("试图创建桌面图标");
                        let add = false;
                        Laya.Browser.window.qg.installShortcut({
                            success: function() {
                                onSuccess && onSuccess();
                                AD_Virtual.Self.Log("创建桌面图标成功");
                                add = true
                            },
                            fail: function(err) {
                                onError && onError(err);
                                console.error("添加桌面错误")
                            },
                            complete: function() {
                                if (!add) {
                                    onFail && onFail()
                                }
                            }
                        })
                    } else {
                        hadCreate && hadCreate();
                        AD_Virtual.Self.Log("已经创建桌面")
                    }
                },
                fail: function(err) {
                    onError && onError(err);
                    console.error("检测错误")
                },
                complete: function() {
                    AD_Virtual.Self.Log("检测桌面图标 complete")
                }
            })
        }
        CanAddDesktop() {
            return this.GetSystemInfoSync2() >= 1044
        }
        HadAddDesktop(onSuccess, onError) {
            Laya.Browser.window.qg.hasShortcutInstalled({
                success: function(res) {
                    onSuccess && onSuccess(res)
                },
                fail: function(err) {
                    onError && onError(err)
                },
                complete: function() {}
            })
        }
        GetSystemInfoSync2() {
            if (this.systemVersion == null) {
                this.systemVersion = Laya.Browser.window.qg.getSystemInfoSync().platformVersionCode
            }
            return this.systemVersion
        }
    }
    class AD_Vivo extends AD_Virtual {
        constructor() {
            super();
            this.ShowAd = AdType.None;
            this.PreLoadNativeData = null;
            this.preloadInter = 10000;
            this.loadArray = [];
            this.loading = false;
            this.mCustomAD = null;
            this.mInterstitial = null;
            this.mVediodata = null;
            this.mGameBanner = null;
            this.mGamePortal = null;
            this.systemVersion = null;
            AD_Virtual.Self = this
        }
        InitAD() {
            AD_Virtual.Self.Log("vivo init ad")
        }
        ClearShowAd(adType) {
            switch (adType) {
                case AdType.Banner:
                    this.showbanner && this.showbanner.hide();
                    this.showbanner && this.showbanner.destroy();
                    this.showbanner = null;
                    break;
                case AdType.GameBanner:
                    this.mGameBanner && this.mGameBanner.destroy();
                    this.mGameBanner = null;
                    break;
                case AdType.GameDrawer:
                    break;
                case AdType.GamePortal:
                    if (this.mGamePortal != null) {
                        this.mGamePortal.isDestroyed = true;
                        this.mGamePortal.destroy()
                    }
                    this.mGamePortal = null;
                    break;
                case AdType.Custom:
                    this.mCustomAD && this.mCustomAD.hide();
                    this.mCustomAD && this.mCustomAD.destroy();
                    this.mCustomAD = null;
                    break;
                case AdType.Interstitial:
                    if (this.mInterstitial && this.mInterstitial.destroy) {
                        this.mInterstitial.destroy();
                        this.mInterstitial = null
                    }
                    break
            }
        }
        HadAd(adType) {
            switch (adType) {
                case AdType.Banner:
                    return false;
                case AdType.GameBanner:
                    return Boolean(this.mGameBanner);
                case AdType.GameDrawer:
                    return false;
                case AdType.GamePortal:
                    return Boolean(this.mGamePortal);
                case AdType.Custom:
                    return Boolean(this.mCustomAD);
                case AdType.Interstitial:
                    return Boolean(this.mInterstitial)
            }
        }
        Reject() {
            this.showbanner && this.showbanner.destroy();
            this.showbanner = null;
            this.mGameBanner && this.mGameBanner.destroy();
            this.mGameBanner = null;
            if (this.mGamePortal != null) {
                this.mGamePortal.isDestroyed = true;
                this.mGamePortal.destroy()
            }
            this.mGamePortal = null;
            this.mCustomAD && this.mCustomAD.destroy();
            this.mCustomAD = null;
            if (this.mInterstitial && this.mInterstitial.destroy) {
                this.mInterstitial.destroy();
                this.mInterstitial = null
            }
        }
        GetNativeData() {
            if (this.PreLoadNativeData == null) return null;
            else {
                let temp = this.PreLoadNativeData;
                this.PreLoadNativeData = null;
                return temp
            }
        }
        Preload_NativeAd(_id, onLoad, onError) {
            this.LoadNativeAD(_id, (res) => {
                this.PreLoadNativeData = res;
                onLoad && onLoad(res)
            }, (err) => {
                AD_Virtual.Self.Log("预加载失败");
                onError && onError(err)
            })
        }
        LoopLoad() {
            if (this.loadArray.length == 0) {
                this.loading = false;
                return
            }
            let temp = this.loadArray.shift();
            this.loading = false;
            this.LoadNativeAD(temp.id, temp.onLoad, temp.onError)
        }
        LoadNativeAD(id, onLoad, onError) {
            if (this.loading) {
                if (this.loadArray.length >= 5) {
                    AD_Virtual.Self.Error("AD--->qg--->原生--->原生广告请求太频繁了 不予加载");
                    return
                }
                let temp = {
                    id: id,
                    onLoad: onLoad,
                    onError: onError,
                };
                this.loadArray.push(temp);
                return
            }
            if (this.PreLoadNativeData && this.PreLoadNativeData.adid == id) {
                this.PreLoadNativeData = null
            }
            this.Reject();
            let nativeAd = Laya.Browser.window.qg.createNativeAd({
                posId: id,
            });
            nativeAd.onLoad(function(res) {
                nativeAd.offLoad();
                nativeAd.offError();
                var _ts = new NativeAdClass(id, nativeAd, res.adList);
                AD_Virtual.Self.Log("AD--->qg--->原生--->加载成功", id, nativeAd, res);
                onLoad && onLoad(_ts)
            });
            nativeAd.onError(function(err) {
                nativeAd.offLoad();
                nativeAd.offError();
                AD_Virtual.Self.Log("AD--->qg--->原生--->加载失败", err, id);
                onError && onError(err)
            });
            nativeAd.load();
            this.loading = true;
            Laya.timer.once(this.preloadInter, this, this.LoopLoad)
        }
        OpenCustomAD(id, style, onLoad, onShow, onClose, onError) {
            if (this.GetSystemInfoSync2() < 1092) {
                AD_Virtual.Self.Error("版本过低 不支持原生模板广告");
                onError && onError("版本检测错误" + this.GetSystemInfoSync2());
                return AdRes.Version
            }
            if (this.mCustomAD == null) {
                this.Reject();
                let self = this;
                let customAd;
                if (!Boolean(style) || style.length != 2) {
                    customAd = Laya.Browser.window.qg.createCustomAd({
                        adUnitId: id,
                    })
                } else {
                    customAd = Laya.Browser.window.qg.createCustomAd({
                        adUnitId: id,
                        style: {
                            top: style[0],
                            left: style[1],
                        }
                    })
                }
                customAd.onLoad(() => {
                    AD_Virtual.Self.Log('customAd广告加载成功');
                    onLoad && onLoad()
                });
                customAd.onHide(() => {
                    AD_Virtual.Self.Log('customAd广告隐藏');
                    self.mCustomAD = null;
                    onClose && onClose()
                });
                customAd.show().then(() => {
                    AD_Virtual.Self.Log('show success');
                    onShow && onShow()
                }).catch((error) => {
                    AD_Virtual.Self.Log('show fail with:' + error.errCode + ',' + error.errMsg);
                    self.mCustomAD = null;
                    onError && onError(error)
                });
                this.mCustomAD = customAd;
                return AdRes.Success
            }
            onError && onError("已经存在 custom ad");
            return AdRes.None
        }
        OpenInterstitial(id, onLoad, onShow, onClose, onError) {
            this.Reject();
            let self = this;
            const interstitialAd = Laya.Browser.window.qg.createInterstitialAd({
                posId: id
            });
            interstitialAd.onError(err => {
                AD_Virtual.Self.Log("插屏广告加载失败", err);
                onError && onError(err);
                interstitialAd.offError()
            });
            interstitialAd.onLoad(() => {
                AD_Virtual.Self.Log("插屏广告加载成功");
                onLoad && onLoad();
                interstitialAd.offLoad()
            });
            interstitialAd.onClose(() => {
                AD_Virtual.Self.Log("插屏广告加载关闭");
                onClose && onClose();
                interstitialAd.offClose()
            });
            interstitialAd.show().then(() => {
                AD_Virtual.Self.Log('插屏广告展示完成');
                onShow && onShow();
                self.ShowAd = AdType.Interstitial
            }).catch((err) => {
                AD_Virtual.Self.Log('插屏广告展示失败', JSON.stringify(err));
                onError && onError(err)
            });
            this.mInterstitial = interstitialAd
        }
        OpenBanner(id, style, onLoad, onShow, onClose, onError) {
            AD_Virtual.Self.Log("AD--->qg--->Banner--->加载");
            let bannerAd;
            if (style && style.length == 3) {
                bannerAd = Laya.Browser.window.qg.createBannerAd({
                    posId: id,
                    style: {
                        top: style[0],
                        left: style[1],
                    },
                    adIntervals: style[2],
                })
            } else {
                bannerAd = Laya.Browser.window.qg.createBannerAd({
                    posId: id,
                })
            }
            this.Reject();
            let self = this;
            bannerAd.onError((err) => {
                AD_Virtual.Self.Log("banner广告加载失败", err);
                onError && onError(err)
            });
            bannerAd.onLoad(function() {
                AD_Virtual.Self.Log('banner 广告加载成功');
                onLoad && onLoad()
            });
            bannerAd.show().then(() => {
                AD_Virtual.Self.Log('banner广告展示完成');
                onShow && onShow();
                self.ShowAd = AdType.Banner
            }).catch((err) => {
                AD_Virtual.Self.Log('banner广告展示失败', JSON.stringify(err));
                onError && onError(err)
            });
            bannerAd.onHide(() => {
                AD_Virtual.Self.Log("banner广告关闭");
                onClose && onClose()
            });
            this.showbanner = bannerAd
        }
        OpenVideo(adid, onLoad, onShow, onClose, onError) {
            this.mVedioLoad = onLoad;
            this.mVedioShow = onShow;
            this.mVedioClose = onClose;
            this.mVedioError = onError;
            let self = this;
            if (this.mVediodata == null) {
                const rewardedAd = Laya.Browser.window.qg.createRewardedVideoAd({
                    posId: adid,
                });
                rewardedAd.onError(err => {
                    AD_Virtual.Self.Log("激励视频广告加载失败", err);
                    self.mVedioError && self.mVedioError()
                });
                rewardedAd.onLoad(function(res) {
                    AD_Virtual.Self.Log('激励视频广告加载完成-onload触发', JSON.stringify(res));
                    self.mVedioLoad && self.mVedioLoad(res);
                    rewardedAd.show().then(() => {
                        AD_Virtual.Self.Log('激励视频广告展示完成');
                        self.mVedioShow && self.mVedioShow()
                    }).catch((err) => {
                        AD_Virtual.Self.Log('激励视频广告展示失败', JSON.stringify(err));
                        self.mVedioError && self.mVedioError()
                    })
                });
                rewardedAd.onClose(function(res) {
                    AD_Virtual.Self.Log('视频广告关闭回调');
                    self.mVedioClose && self.mVedioClose(res)
                });
                this.mVediodata = rewardedAd;
                AD_Virtual.Self.Log("AD--->qg--->广告--->加载load")
            } else {
                this.mVediodata.load()
            }
            return AdRes.Success
        }
        OpenGameBanner(id, top, left, orientation, onLoad, onShow, onClose, onError) {
            if (this.GetSystemInfoSync2() >= 1076) {
                let gameBannerAd;
                gameBannerAd = Laya.Browser.window.qg.createBoxBannerAd({
                    posId: id
                });
                this.Reject();
                let self = this;
                gameBannerAd.onLoad(function() {
                    AD_Virtual.Self.Log('互推盒子横幅广告加载成功');
                    onLoad && onLoad()
                });
                gameBannerAd.onError(function(err) {
                    AD_Virtual.Self.Log('互推盒子横幅广告错误', err);
                    onError && onError(err)
                });
                gameBannerAd.show().then(function() {
                    AD_Virtual.Self.Log('互推盒子横幅广告 show success');
                    onShow && onShow();
                    self.ShowAd = AdType.GameBanner
                }).catch(function(error) {
                    AD_Virtual.Self.Log('show fail with:' + error.errCode + ',' + error.errMsg);
                    onError && onError(error)
                });
                this.mGameBanner = gameBannerAd
            }
            AD_Virtual.Self.Error("版本过低 不支持互推横幅");
            return AdRes.Version
        }
        OpenGamePortal(id, onShow, onClose, onError) {
            if (this.GetSystemInfoSync2() < 1076) {
                AD_Virtual.Self.Error("版本过低 不支持互推横幅");
                return AdRes.Version
            }
            let GamePortalAd = Laya.Browser.window.qg.createBoxPortalAd({
                posId: id
            });
            this.Reject();
            GamePortalAd.show().then(function() {
                AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> show success');
                onShow && onShow()
            });
            GamePortalAd.onError(function(err) {
                console.log("盒子九宫格广告加载失败", err);
                onError && onError(err)
            });
            GamePortalAd.onClose(function() {
                AD_Virtual.Self.Log('AD--->qg--->createGamePortalAd---> 互推盒子九宫格广告关闭');
                onClose && onClose();
                GamePortalAd.show()
            });
            this.mGamePortal = GamePortalAd
        }
        OpenGameDrawer(id, style, onShow, onError) {}
        AddToDesktop(onSuccess, onFail, onError, hadCreate) {
            if (this.GetSystemInfoSync2() < 1044) {
                AD_Virtual.Self.Error("版本过低 不支持添加到桌面");
                onError && onError(null)
            }
            Laya.Browser.window.qg.hasShortcutInstalled({
                success: function(res) {
                    if (res == false) {
                        AD_Virtual.Self.Log("试图创建桌面图标");
                        let add = false;
                        Laya.Browser.window.qg.installShortcut({
                            success: function() {
                                onSuccess && onSuccess();
                                AD_Virtual.Self.Log("创建桌面图标成功");
                                add = true
                            },
                            fail: function(err) {
                                onError && onError(err);
                                console.error("添加桌面错误")
                            },
                            complete: function() {
                                if (!add) {
                                    onFail && onFail()
                                }
                            }
                        })
                    } else {
                        hadCreate && hadCreate();
                        AD_Virtual.Self.Log("已经创建桌面")
                    }
                },
                fail: function(err) {
                    onError && onError(err);
                    console.error("检测错误")
                },
                complete: function() {
                    AD_Virtual.Self.Log("检测桌面图标 complete")
                }
            })
        }
        CanAddDesktop() {
            return this.GetSystemInfoSync2() >= 1044
        }
        HadAddDesktop(onSuccess, onError) {
            Laya.Browser.window.qg.hasShortcutInstalled({
                success: function(res) {
                    onSuccess && onSuccess(res)
                },
                fail: function(err) {
                    onError && onError(err)
                },
                complete: function() {}
            })
        }
        GetSystemInfoSync2() {
            if (this.systemVersion == null) {
                this.systemVersion = Laya.Browser.window.qg.getSystemInfoSync().platformVersionCode
            }
            return this.systemVersion
        }
    }
    class AD {
        constructor() {
            this._ADChannel = new AD_None()
        }
        static get Instance() {
            if (this._instance == null) {
                this._instance = new AD()
            }
            return this._instance
        }
        get Channel() {
            return this._ADChannel
        }
        Init() {
            if (Laya.Browser.onQGMiniGame) {
                this._ADChannel = new AD_oppo()
            } else if (Laya.Browser.onVVMiniGame) {
                this._ADChannel = new AD_Vivo()
            }
            this._ADChannel.InitAD()
        }
    }
    AD._instance = null;
    class _EventName {
        constructor() {
            this.LaunchGame = "LaunchGame";
            this.EnterLevel = "EnterLevel";
            this.ResetLevel = "ResetLevel";
            this.RefreshObj = "RefreshObj";
            this.ERR = "ERR";
            this.WIN = "WIN"
        }
    }
    const EventName = new _EventName();
    const ResPath = {
        "attack.mp3": "sound/attack.mp3",
        "BGM.mp3": "sound/BGM.mp3",
        "BGM2.mp3": "sound/BGM2.mp3",
        "btn.mp3": "sound/btn.mp3",
        "drop.mp3": "sound/drop.mp3",
        "err.mp3": "sound/err.mp3",
        "win.mp3": "sound/win.mp3",
        "Scene3DGIReflection.ltcb.ls": "LayaScene3D/Conventional/Assets/Scenes/Scene3DGIReflection.ltcb.ls",
        "Scene3D.ls": "LayaScene3D/Conventional/Scene3D.ls",
        "blue_Imprint.lh": "LayaScene3D/Conventional/blue_Imprint.lh",
        "Directional_Light.lh": "LayaScene3D/Conventional/Directional_Light.lh",
        "Enemy_Imprint.lh": "LayaScene3D/Conventional/Enemy_Imprint.lh",
        "Level1.lh": "LayaScene3D/Conventional/Level1.lh",
        "Level10.lh": "LayaScene3D/Conventional/Level10.lh",
        "Level2.lh": "LayaScene3D/Conventional/Level2.lh",
        "Level3.lh": "LayaScene3D/Conventional/Level3.lh",
        "Level4.lh": "LayaScene3D/Conventional/Level4.lh",
        "Level5.lh": "LayaScene3D/Conventional/Level5.lh",
        "Level6.lh": "LayaScene3D/Conventional/Level6.lh",
        "Level7.lh": "LayaScene3D/Conventional/Level7.lh",
        "Level8.lh": "LayaScene3D/Conventional/Level8.lh",
        "Level9.lh": "LayaScene3D/Conventional/Level9.lh",
        "Map_1.lh": "LayaScene3D/Conventional/Map_1.lh",
        "Map_2.lh": "LayaScene3D/Conventional/Map_2.lh",
        "Map_3.lh": "LayaScene3D/Conventional/Map_3.lh",
        "Obj_1.lh": "LayaScene3D/Conventional/Obj_1.lh",
        "Obj_2.lh": "LayaScene3D/Conventional/Obj_2.lh",
        "Placed.lh": "LayaScene3D/Conventional/Placed.lh"
    };
    let _ResPath = {
        "attack.mp3": null,
        "BGM.mp3": null,
        "BGM2.mp3": null,
        "btn.mp3": null,
        "drop.mp3": null,
        "err.mp3": null,
        "win.mp3": null,
        "Scene3DGIReflection.ltcb.ls": null,
        "Scene3D.ls": null,
        "blue_Imprint.lh": null,
        "Directional_Light.lh": null,
        "Enemy_Imprint.lh": null,
        "Level1.lh": null,
        "Level10.lh": null,
        "Level2.lh": null,
        "Level3.lh": null,
        "Level4.lh": null,
        "Level5.lh": null,
        "Level6.lh": null,
        "Level7.lh": null,
        "Level8.lh": null,
        "Level9.lh": null,
        "Map_1.lh": null,
        "Map_2.lh": null,
        "Map_3.lh": null,
        "Obj_1.lh": null,
        "Obj_2.lh": null,
        "Placed.lh": null
    };
    const ResGet = new Proxy(_ResPath, {
        get: function(target, propKey, receiver) {
            let result = Laya.loader.getRes(ResPath[propKey]);
            return result ? result : null
        }
    });
    let LOCALDATA = {
        VERSION: 1,
        CurCoinNum: 0,
        CurLevelNum: 1,
        NewUser: null,
        FirstLogin: null,
        FirstLoginTime: null,
        YHXY: false,
        SingCount: 1,
        SingTime: null,
        DrawNum: 1,
        LiheProgress: 0,
        MaxObjNum: 3,
        RoleLevelNum: 0,
        CoinBonusNum: 0,
        AllSkin: [1, 2, 3, 4, 5, 6, 7, 8, 9],
        HaveSkin: [],
        UseSkin: 0,
    };
    let identification = "__Star__";
    let InitState = false;

    function _InitLocaData() {
        if (InitState) return;
        InitState = true;
        if (JSON_Parse(Laya.LocalStorage.getJSON(identification + "VERSION")) != LocalData.VERSION) {
            for (const key in LOCALDATA) {
                LocalData[key] = LocalData[key]
            }
        } else {
            for (const key in LOCALDATA) {
                let data = JSON_Parse(Laya.LocalStorage.getJSON(identification + key));
                if (!data && data != 0) {
                    LocalData[key] = LocalData[key]
                } else {
                    LocalData[key] = data
                }
            }
        }
    }
    let LocalData = new Proxy(LOCALDATA, {
        get(target, key) {
            _InitLocaData();
            return target[key]
        },
        set(target, key, value) {
            Reflect.set(target, key, value);
            Laya.LocalStorage.setJSON(identification + key, JSON_Stringify(value));
            _InitLocaData();
            return true
        },
    });

    function JSON_Parse(str) {
        if (typeof str == "string") {
            try {
                var obj = JSON.parse(str);
                if (typeof obj == "object" && obj) {
                    return obj
                } else {
                    return str
                }
            } catch (e) {
                return str
            }
        } else {
            return str
        }
    }

    function JSON_Stringify(obj) {
        if (typeof obj === "object" && obj != null) {
            return JSON.stringify(obj)
        } else {
            return obj
        }
    }
    class _SoundManager {
        constructor() {
            this.TypeState = {
                ZD: true,
                YY: true,
                YX: true,
            };
            this.SoundConfig = {
                bgm: null,
                btn: null,
                attack: null,
                drop: null,
                err: null,
                win: null,
            }
        }
        init() {
            Laya.stage.on(Laya.Event.FOCUS, this, () => {
                console.log("获得舞台焦点（切回游戏）的处理");
                this.Setting("ZD");
                this.Setting("YX");
                this.Setting("ZD");
                this.Setting("YX")
            });
            this.SoundConfig = {
                bgm: {
                    url: ResPath["BGM2.mp3"],
                    length: 30275.916666666668,
                    type: "YY",
                    loops: 0,
                    State: false,
                    CurState: false,
                },
                btn: {
                    url: ResPath["btn.mp3"],
                    length: 132.72916666666669,
                    type: "YX",
                    loops: 0,
                    State: false,
                    CurState: false,
                },
                attack: {
                    url: ResPath["attack.mp3"],
                    length: 548.5625,
                    type: "YX",
                    loops: 0,
                    State: false,
                    CurState: false,
                },
                drop: {
                    url: ResPath["drop.mp3"],
                    length: 539.4375,
                    type: "YX",
                    loops: 0,
                    State: false,
                    CurState: false,
                },
                err: {
                    url: ResPath["err.mp3"],
                    length: 3186.9375,
                    type: "YX",
                    loops: 0,
                    State: false,
                    CurState: false,
                },
                win: {
                    url: ResPath["win.mp3"],
                    length: 4860.895833333333,
                    type: "YX",
                    loops: 0,
                    State: false,
                    CurState: false,
                },
            }
        }
        play(Conifg, loops = 1) {
            let config = Conifg;
            let typestate = this.TypeState[config.type];
            config.State = true;
            config.loops = loops;
            Laya.timer.loop(config.length - 100, config, () => {
                config.loops--;
                playing()
            });
            playing();

            function playing() {
                if (config.State && 0 < config.loops && typestate) {
                    Laya.SoundManager.playSound(config.url, 1);
                    config.CurState = true
                } else if (config.State == false) {
                    console.log("不满足播放条件");
                    config.State = false;
                    Laya.timer.clearAll(config);
                    Laya.SoundManager.stopSound(config.url);
                    config.CurState = false
                }
            }
        }
        continue (Conifg) {
            let config = Conifg;
            if (config.State == true && config.CurState == false) {
                this.play(config, config.loops)
            }
        }
        pause(Conifg) {
            let config = Conifg;
            Laya.timer.clearAll(config);
            Laya.SoundManager.stopSound(config.url);
            config.CurState = false
        }
        stop(Conifg) {
            Conifg.State = false;
            this.pause(Conifg)
        }
        Setting(type) {
            this.TypeState[type] = !this.TypeState[type];
            for (let key in this.SoundConfig) {
                let value = this.SoundConfig[key];
                if (value.type == type) {
                    if (this.TypeState[type] == true) {
                        this.continue(this.SoundConfig[key])
                    } else {
                        this.pause(this.SoundConfig[key])
                    }
                }
            }
            return this.TypeState[type]
        }
        Shake() {}
        test() {
            for (let key in this.SoundConfig) {
                let a = Laya.SoundManager.playSound(this.SoundConfig[key].url);
                Laya.timer.once(3000, this, () => {
                    console.log(this.SoundConfig[key].url, a.duration * 1000)
                })
            }
        }
    }
    let SoundManager = new _SoundManager();
    class Tools_UI {
        static Tip(title) {
            let TIPLabel = Laya.stage.getChildByName("TIPLabel");
            if (TIPLabel != null) {
                TIPLabel.destroy()
            }
            let Label = new Laya.Label(title);
            Label.centerX = 0;
            Label.centerY = 0;
            Label.fontSize = 40;
            Label.font = "Microsoft YaHei";
            Label.color = "#ffffff";
            Label.align = "center";
            Label.valign = "middle";
            Label.bgColor = "#00000099";
            Label.padding = "20,50,20,50";
            Label.zOrder = 99;
            Label.mouseEnabled = true;
            Label.name = "TIPLabel";
            Laya.stage.addChild(Label);
            Laya.Tween.to(Label, {
                centerY: -200
            }, 2500);
            Laya.Tween.to(Label, {
                alpha: 0
            }, 1500, null, null, 1000);
            Laya.timer.once(3000, this, () => {
                if (Label.destroyed == false) {
                    Label.removeSelf();
                    Label.destroy()
                }
            })
        }
        static TipLoading() {
            let Label = new Laya.Label("加载中");
            Label.centerX = 0;
            Label.centerY = 0;
            Label.fontSize = 40;
            Label.font = "Microsoft YaHei";
            Label.color = "#ffffff";
            Label.align = "center";
            Label.valign = "middle";
            Label.bgColor = "#00000099";
            Label.padding = "20,50,20,50";
            Label.zOrder = 99;
            Label.mouseEnabled = true;
            let Box = new Laya.Box();
            Box.top = 0;
            Box.right = 0;
            Box.bottom = 0;
            Box.left = 0;
            Box.mouseEnabled = true;
            Box.addChild(Label);
            Laya.stage.addChild(Box);
            return () => {
                Box.removeSelf();
                Box.destroy()
            }
        }
        static NodeToXY(Node) {
            let _Node = Node;
            let pivotX = _Node.pivotX;
            if (_Node.anchorX || _Node.anchorX == 0) {
                let pivotX = _Node.anchorX * _Node.width;
                _Node.x += pivotX * _Node.scaleX
            }
            let pivotY = _Node.pivotY;
            if (_Node.anchorY || _Node.anchorY == 0) {
                pivotY = _Node.anchorY * _Node.height;
                _Node.y += pivotY * _Node.scaleY
            }
            _Node.anchorX = NaN;
            _Node.anchorY = NaN;
            _Node.pivotX = pivotX;
            _Node.pivotY = pivotY;
            let _NodeX = _Node.x - _Node.pivotX * _Node.scaleX + (_Node.width * _Node.scaleX) / 2;
            let _NodeY = _Node.y - _Node.pivotY * _Node.scaleY + (_Node.height * _Node.scaleY) / 2;
            _Node.pivotX = _Node.width / 2;
            _Node.pivotY = _Node.height / 2;
            _Node.top = NaN;
            _Node.left = NaN;
            _Node.right = NaN;
            _Node.bottom = NaN;
            _Node.centerX = NaN;
            _Node.centerY = NaN;
            _Node.x = _NodeX;
            _Node.y = _NodeY
        }
        static AnimationUI_1(Image, time = 3000) {
            if (!time) time = 3000;
            Image.scaleX = 0;
            Image.alpha = 1;
            Laya.Tween.to(Image, {
                scaleX: 1
            }, time * 0.1, null, new Laya.Handler(this, () => {
                Laya.Tween.to(Image, {
                    alpha: 0
                }, time * 0.1)
            }));
            Laya.timer.loop(time, Image, () => {
                if (Image.destroyed == true) {
                    Laya.timer.clearAll(Image);
                    return null
                }
                Image.scaleX = 0;
                Image.alpha = 1;
                Laya.Tween.to(Image, {
                    scaleX: 1
                }, time * 0.1, null, new Laya.Handler(this, () => {
                    Laya.Tween.to(Image, {
                        alpha: 0
                    }, time * 0.1)
                }))
            })
        }
        static AnimationUI_BtnScale(Btn, Type, Scale) {
            if (!Type) Type = 1;
            if (!Scale) Scale = 0.2;
            Btn.mouseEnabled = true;
            let scaleX = Btn.scaleX;
            let scaleY = Btn.scaleY;
            Btn.offAll(Laya.Event.MOUSE_DOWN);
            Btn.on(Laya.Event.MOUSE_DOWN, this, () => {
                if (Type == 1) {
                    Laya.Tween.to(Btn, {
                        scaleX: scaleX + Scale,
                        scaleY: scaleY + Scale
                    }, 100)
                } else if (Type == 2) {
                    Laya.Tween.to(Btn, {
                        scaleX: scaleX - Scale,
                        scaleY: scaleY - Scale
                    }, 100)
                }
                Laya.Tween.to(Btn, {
                    scaleX: scaleX,
                    scaleY: scaleY
                }, 150, null, null, 100)
            })
        }
        static AnimationUI_Show(Node, Type, Time, delay) {
            if (!Time) Time = 500;
            if (!Type) Type = 5;
            if (!delay) delay = 0;
            Tools_UI.NodeToXY(Node);
            switch (Type) {
                case 1:
                    Laya.Tween.from(Node, {
                        y: 0 - Node.height
                    }, Time, Laya.Ease.elasticInOut, null, delay);
                    break;
                case 2:
                    Laya.Tween.from(Node, {
                        x: Laya.stage.height + Node.width
                    }, Time, Laya.Ease.elasticInOut, null, delay);
                    break;
                case 3:
                    Laya.Tween.from(Node, {
                        y: Laya.stage.height + Node.height
                    }, Time, Laya.Ease.elasticInOut, null, delay);
                    break;
                case 4:
                    Laya.Tween.from(Node, {
                        x: 0 - Node.width
                    }, Time, Laya.Ease.elasticInOut, null, delay);
                    break;
                case 5:
                    Laya.Tween.from(Node, {
                        scaleX: Node.scaleX * 0.1,
                        scaleY: Node.scaleY * 0.1
                    }, Time, Laya.Ease.elasticOut, null, delay);
                    break;
                case 6:
                    Laya.Tween.from(Node, {
                        scaleX: Node.scaleX * 2,
                        scaleY: Node.scaleY * 2
                    }, Time, Laya.Ease.elasticOut, null, delay);
                    break
            }
            Node.visible = false;
            Laya.timer.once(delay, this, () => {
                Node.visible = true
            })
        }
    }
    class View_Setting extends ui.View_SettingUI {
        onAwake() {
            this.AddEvent();
            this.AddAnim();
            this.UpdateUI()
        }
        AddEvent() {
            nativeOpen("设置页",1)
            this.back.on(Laya.Event.CLICK, this, this.ClickBack);
            this.yx_box.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                SoundManager.Setting("YX");
                this.UpdateUI()
            });
            this.yy_box.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                Laya.SoundManager.musicMuted = !Laya.SoundManager.musicMuted;
                this.UpdateUI()
            })
        }
        ClickBack() {
            SoundManager.play(SoundManager.SoundConfig.btn);
            if (View_Setting.DATA && View_Setting.DATA.OnClose) {
                View_Setting.DATA.OnClose()
            }
            UIControl.RemoveUI(View_Setting)
        }
        AddAnim() {
            Tools_UI.AnimationUI_BtnScale(this.back);
            Tools_UI.AnimationUI_Show(this.centerBox, 5, 500)
        }
        UpdateUI() {
            if (SoundManager.TypeState.YX) {
                this.yx_off.visible = false;
                this.yx_on.visible = true
            } else {
                this.yx_off.visible = true;
                this.yx_on.visible = false
            }
            if (!Laya.SoundManager.musicMuted) {
                this.yy_off.visible = false;
                this.yy_on.visible = true
            } else {
                this.yy_off.visible = true;
                this.yy_on.visible = false
            }
        }
    }
    View_Setting.NAME = "View_Setting";
    View_Setting.AUTO = true;
    View_Setting.DATA = null;
    class View_Game extends ui.View_GameUI {
        onAwake() {
            nativeOpen("游戏页",1)
            this.on(Laya.Event.MOUSE_DOWN, GameControl.I.PlacedC, GameControl.I.PlacedC.Down);
            this.on(Laya.Event.MOUSE_MOVE, GameControl.I.PlacedC, GameControl.I.PlacedC.Move);
            this.on(Laya.Event.MOUSE_OUT, GameControl.I.PlacedC, GameControl.I.PlacedC.LoosenHand);
            this.on(Laya.Event.MOUSE_UP, GameControl.I.PlacedC, GameControl.I.PlacedC.LoosenHand);
            Laya.timer.frameLoop(1, this, () => {
                this.obj_num.text = GameControl.I.usableNum + "";
                this.level_num.text = (window.isRussian ? "Уровень " : "Level ") + LocalData.CurLevelNum;
                this.coin_num.text = LocalData.CurCoinNum + ""
            });
            this.btn_setting.on(Laya.Event.CLICK, this, () => {
                UIControl.ShowUI(View_Setting)
            })
        }
        onEnable() {
            console.log("隐藏原生广告！")
        }
        onDisable() {
            UIControl.RemoveUI(View_Setting)
        }
    }
    View_Game.NAME = "View_Game";
    View_Game.AUTO = true;
    View_Game.DATA = null;
    class InstanceBase {
        constructor() {
            this.onAwake()
        }
        static get _I() {
            if (this._Instance == null) this._Instance = new this();
            return this._Instance
        }
        onAwake() {}
    }
    InstanceBase._Instance = null;
    var Tools_Plant = new(class ToolsData {
        Random(min, max) {
            return Math.floor(Math.random() * (max + 1 - min) + min)
        }
        Vector2ToAngle(X, Y) {
            if (Y > 0) return (360 - (Math.atan(X / Y) * 180) / Math.PI) % 360;
            else if (Y < 0) return 360 - ((Math.atan(X / Y) * 180) / Math.PI + 180);
            else null
        }
    })();
    class View_Draw extends ui.View_DrawUI {
        constructor() {
            super(...arguments);
            this.IsDraw = false;
            this.LiheProgress = null
        }
        onAwake() {
            nativeOpen("转盘页",1)
            this.AddEvent();
            this.AddAnim();
            this.video_icon.visible = true;
            if (LocalData.DrawNum == 1) {
                this.video_icon.visible = false
            }
        }
        onEnable() {}
        AddEvent() {
            this.btn_back.on(Laya.Event.CLICK, this, this.ClickBackBtn);
            this.give_btn.on(Laya.Event.CLICK, this, this.ClickGiveBtn)
        }
        ClickBackBtn() {
            SoundManager.play(SoundManager.SoundConfig.btn);
            UIControl.ShowUI(View_Main);
            UIControl.RemoveUI(View_Draw)
        }
        ClickGiveBtn() {
            let btn = this;
            SoundManager.play(SoundManager.SoundConfig.btn);
            if (this.IsDraw == false) {
                if (this.video_icon.visible == true) {
                    playVideo(res => {
                        if (res) {
                            btn.IsDraw = true;
                            console.log("Drawing");
                            let Random = Tools_Plant.Random(1, 5);
                            if (Random == 6) {
                                Random = Tools_Plant.Random(1, 6)
                            }
                            btn.pointer.rotation = 0;
                            Laya.Tween.to(btn.pointer, {
                                rotation: Random * (360 / 6) + 360 * 3
                            }, 3000, Laya.Ease.expoOut, Laya.Handler.create(this, () => {
                                btn.video_icon.visible = true;
                                btn.GiveDrawMoney(Random);
                                if (LocalData.LiheProgress < 5) {
                                    LocalData.LiheProgress += 1
                                }
                                btn.UpLibaoState();
                                btn.IsDraw = false
                            }));
                            console.log("end ad")
                        }
                    },1002)
                } else {
                    this.IsDraw = true;
                    let Random = Tools_Plant.Random(1, 5);
                    if (Random == 6) {
                        Random = Tools_Plant.Random(1, 6)
                    }
                    this.pointer.rotation = 0;
                    Laya.Tween.to(this.pointer, {
                        rotation: Random * (360 / 6) + 360 * 3
                    }, 3000, Laya.Ease.expoOut, Laya.Handler.create(this, () => {
                        this.video_icon.visible = true;
                        this.GiveDrawMoney(Random);
                        if (LocalData.LiheProgress < 5) {
                            LocalData.LiheProgress += 1
                        }
                        this.UpLibaoState();
                        this.IsDraw = false
                    }))
                }
            } else {
                Tools_UI.Tip(window.isRussian ? "Идет розыгрыш, пожалуйста, терпеливо ждите!" : "The lottery is in progress, please wait patiently!")
            }
        }
        GiveDrawMoney(Random) {
            this.video_icon.visible = true;
            LocalData.DrawNum -= 1;
            let CoinNum = 0;
            switch (Random) {
                case 1:
                    CoinNum = 400;
                    break;
                case 2:
                    CoinNum = 200;
                    break;
                case 3:
                    CoinNum = 700;
                    break;
                case 4:
                    CoinNum = 500;
                    break;
                case 5:
                    CoinNum = 300;
                    break;
                case 6:
                    CoinNum = 100;
                    break
            }
            if (CoinNum != 0) {
                LocalData.CurCoinNum += CoinNum;
                Tools_UI.Tip((window.isRussian ? "Вы получили: " : "获得金币: ") + CoinNum)
            }
            if (CoinNum == 0) {
                this.CLickLibao()
            }
        }
        RandomSkin() {
            let result = [];
            LocalData["SkinAll1"].forEach((element) => {
                if (LocalData["SkinHave1"].indexOf(element) == -1 || LocalData["SkinHave1"].length == LocalData["SkinAll1"].length) {
                    result.push(element)
                }
            });
            return result
        }
        UpLibaoState() {
            if (LocalData.LiheProgress >= 5) {
                this.LibaoIcon.offAllCaller(this);
                this.ani2.play(null, true);
                this.LibaoIcon.once(Laya.Event.CLICK, this, () => {
                    this.CLickLibao()
                })
            }
        }
        CLickLibao() {
            LocalData.CurCoinNum += 1000;
            Tools_UI.Tip((window.isRussian ? "Вы получили: " : "获得金币: ") + 1000);
            LocalData.LiheProgress = 0;
            this.ani2.stop()
        }
        AddAnim() {
            Tools_UI.AnimationUI_BtnScale(this.give_btn)
        }
    }
    View_Draw.NAME = "View_Draw";
    View_Draw.AUTO = true;
    View_Draw.DATA = null;
    View_Draw.isBackFirst = false;
    class View_OverErr extends ui.View_OverErrUI {
        onAwake() {
            nativeOpen("失败页",1)
            SoundManager.play(SoundManager.SoundConfig.err);
            let addCoin = LocalData.CoinBonusNum * 30 + 30;
            LocalData.CurCoinNum += LocalData.CoinBonusNum * 30 + 30;
            this.coin_num.text = "+" + addCoin;
            let isFirst = false;
            this.btn_reset.on(Laya.Event.CLICK, this, () => {
                console.log("点击了继续按钮");
                SoundManager.play(SoundManager.SoundConfig.btn);
                GameControl.I.RessetLevel();
                UIControl.ShowUI(View_Main);
                UIControl.RemoveUI(View_OverErr);
                if (LocalData.CurLevelNum % 2 == 0) {
                    UIControl.ShowUI(View_Draw)
                }
            });
            setTimeout(() => {
                ShowInter();
            }, 1000);
        }
    }
    View_OverErr.NAME = "View_OverErr";
    View_OverErr.AUTO = true;
    View_OverErr.DATA = null;
    class View_OverWin extends ui.View_OverWinUI {
        onAwake() {
            nativeOpen("胜利页",1)
            SoundManager.play(SoundManager.SoundConfig.win);
            let addCoin = LocalData.CoinBonusNum * 30 + 100;
            LocalData.CurCoinNum += LocalData.CoinBonusNum * 30 + 200;
            this.coin_num.text = '+' + addCoin;
            if (LocalData.CurLevelNum + 1 > 10) {
                LocalData.CurLevelNum = 1
            } else {
                LocalData.CurLevelNum += 1
            }
            let isFirst = false;
            this.btn_reset.on(Laya.Event.CLICK, this, () => {
                console.log("点击了继续按钮");
                SoundManager.play(SoundManager.SoundConfig.btn);
                GameControl.I.RessetLevel();
                UIControl.ShowUI(View_Main, 1);
                UIControl.RemoveUI(View_OverWin)
            });
            setTimeout(() => {
                ShowInter();
            }, 1000);
        }
    }
    View_OverWin.NAME = "View_OverWin";
    View_OverWin.AUTO = true;
    View_OverWin.DATA = null;
    class DoorCom extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.Owner = null;
            this.Pos1 = new Laya.Vector3();
            this.Pos2 = new Laya.Vector3()
        }
        onStart() {
            this.Owner = this.owner;
            this.Owner.getChildByName("select").active = false;
            this.Owner.getChildByName("pass").active = false
        }
        onUpdate() {
            this.Pos1.setValue(this.Owner.transform.position.x, 0, this.Owner.transform.position.z);
            this.Pos2.setValue(GameControl.I.PlacedC.Owner.transform.position.x, 0, GameControl.I.PlacedC.Owner.transform.position.z);
            if (Laya.Vector3.distance(this.Pos1, this.Pos2) < 1.5) {
                this.Owner.getChildByName("select").active = true;
                this.Owner.getChildByName("normal").active = false
            } else {
                this.Owner.getChildByName("select").active = false;
                this.Owner.getChildByName("normal").active = true
            }
        }
    }
    class Tools_Game3D {
        static addCharacterController(Node) {
            let CharacterController = Node.addComponent(Laya.CharacterController);
            let PhysicsCollider = Node.getComponent(Laya.PhysicsCollider);
            let colliderShape = PhysicsCollider.colliderShape.clone();
            CharacterController.colliderShape = colliderShape;
            PhysicsCollider.colliderShape.destroy();
            PhysicsCollider.destroy();
            return CharacterController
        }
        static CameraRay(Scene3D, Camera, Ray, OutHitResult, Point) {
            Camera.viewportPointToRay(Point, Ray);
            Scene3D.physicsSimulation.rayCast(Ray, OutHitResult);
            return OutHitResult
        }
        static CameraRayAll(Scene3D, Camera, Ray, OutHitResult, Point) {
            Camera.viewportPointToRay(Point, Ray);
            Scene3D.physicsSimulation.rayCastAll(Ray, OutHitResult);
            return OutHitResult
        }
        static ShowFrame() {
            let ShowFrame = Laya.stage.getChildByName("ShowFrameLabel");
            if (ShowFrame == null) {
                ShowFrame = new Laya.Label("");
                ShowFrame.name = "ShowFrameLabel";
                ShowFrame.fontSize = 24;
                ShowFrame.color = "#00000066";
                ShowFrame.bgColor = "#ffffff33";
                ShowFrame.left = 10;
                ShowFrame.bottom = 10;
                ShowFrame.zOrder = 99999;
                Laya.stage.addChild(ShowFrame)
            }
            let currFrame = 0;
            Laya.timer.clearAll(Tools_Game3D.ShowFrame);
            Laya.timer.loop(1000, Tools_Game3D.ShowFrame, () => {
                ShowFrame.text = "FPS:" + (Laya.timer.currFrame - currFrame) + "-" + Laya.timer.delta + "ms";
                currFrame = Laya.timer.currFrame
            })
        }
        static add3DChild(parent, child) {
            let pos = {
                x: child.transform.position.x,
                y: child.transform.position.y,
                z: child.transform.position.z,
            };
            let rot = {
                x: child.transform.rotation.x,
                y: child.transform.rotation.y,
                z: child.transform.rotation.z,
                w: child.transform.rotation.w,
            };
            parent.addChild(child);
            child.transform.position.setValue(pos.x, pos.y, pos.z);
            child.transform.rotation.x = rot.x;
            child.transform.rotation.y = rot.y;
            child.transform.rotation.z = rot.z;
            child.transform.rotation.w = rot.w;
            child.transform.position = child.transform.position;
            child.transform.rotation = child.transform.rotation
        }
        static Find(path, nodeObject) {
            let pathArr = path.split("/");
            let curNode = nodeObject;
            pathArr.forEach((item) => {
                curNode = curNode.getChildByName(item)
            });
            return curNode
        }
    }
    class ObjRoleCom extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.Owner = null;
            this.isPlayer = true;
            this.levelNum = 0;
            this.skinIndex = 0;
            this.maxBlood = 1;
            this.curBlood = 1;
            this.AttackCur = 1
        }
        onStart() {
            this.Owner = this.owner;
            this.upDateDisplay();
            this.upDateSkin();
            this.Owner.getChildByName("BloodExplosionSpikyAnimated").active = false;
            this.Owner.getChildByName("GenericDeath").active = false;
            this.Owner.getChildByName("body").getChildByName("Obj_Skin").getChildByName("mixamorig:Hips").active = false
        }
        onUpdate() {}
        upDateDisplay() {
            if (!this.isPlayer && this.levelNum == 6) {
                this.curBlood = this.maxBlood = (this.levelNum + 1) * 1.2 * 3;
                this.AttackCur = (this.levelNum + 1) * 1.2 * 100
            } else {
                this.curBlood = this.maxBlood = (this.levelNum + 1) * 1.2 * 3;
                this.AttackCur = (this.levelNum + 1) * 1.2
            }
            let Enemyconfig = [
                ["Stickman_Enemy", "helmet_1", "armour_1"],
                ["Stickman_Enemy", "helmet_1", "armour_1", "weapon_4"],
                ["Stickman_Enemy", "armour_2", "weapon_4"],
                ["Stickman_Enemy", "armour_2", "weapon_5"],
                ["Stickman_Enemy", "helmet_2", "armour_1", "weapon_6"],
                ["Stickman_Enemy", "armour_3", "weapon_6"],
                ["BossWeapon", "BossBody"],
            ];
            let Playerconfig = [
                ["Stickman_Player"],
                ["Stickman_Player", "weapon_1"],
                ["Stickman_Player", "weapon_1", "helmet_1"],
                ["Stickman_Player", "weapon_2", "helmet_1"],
                ["Stickman_Player", "weapon_2", "helmet_2"],
                ["Stickman_Player", "weapon_3", "helmet_2"],
                ["Stickman_Player", "weapon_4", "helmet_2"],
            ];
            let AnimNode = Tools_Game3D.Find("body/Anim", this.Owner);
            for (let i = 0; i < AnimNode.numChildren; i++) {
                let item = AnimNode.getChildAt(i);
                if (this.isPlayer) {
                    if (Playerconfig[this.levelNum].indexOf(item.name) == -1) {
                        item.active = false
                    } else {
                        item.active = true
                    }
                } else {
                    if (Enemyconfig[this.levelNum].indexOf(item.name) == -1) {
                        item.active = false
                    } else {
                        item.active = true
                    }
                }
            }
        }
        upDateSkin() {
            if (this.levelNum == 6 && !this.isPlayer) {} else {
                this.skinIndex = LocalData.UseSkin;
                if (!this.isPlayer) {
                    this.skinIndex = 0
                }
                let ObjSkin = Tools_Game3D.Find("body/Obj_Skin", this.Owner);
                for (let i = 1; i <= 9; i++) {
                    let skinItem = ObjSkin.getChildByName("skin_" + i);
                    if (i == this.skinIndex) {
                        skinItem.active = true
                    } else {
                        skinItem.active = false
                    }
                }
            }
        }
    }
    class ObjCom extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.Owner = null;
            this.Rig3D = null;
            this.isDrop = false;
            this.isRun = false;
            this.Anim = null;
            this.AnimSkin = null;
            this.volume = 1.2;
            this.stopVolume = 0;
            this.rivalryNode = null;
            this.AnimName = "";
            this.targetNode = null;
            this.targetPos = new Laya.Vector3();
            this.inputPos = new Laya.Vector3();
            this.forceObj = new Laya.Vector3();
            this.maxForce = 0.0025
        }
        onStart() {
            this.Owner = this.owner;
            this.Rig3D = this.Owner.getComponent(Laya.Rigidbody3D);
            this.Anim = this.Owner.getChildAt(0).getChildAt(0).getComponent(Laya.Animator);
            this.AnimSkin = this.Owner.getChildAt(0).getChildAt(1).getComponent(Laya.Animator);
            this.Anim.crossFade("Idle", 0);
            this.AnimSkin.crossFade("Idle", 0);
            this.Rig3D.enabled = true;
            this.Rig3D.linearDamping = 0.99;
            this.Rig3D.sleepLinearVelocity = 0.1;
            this.Owner.getChildByName("BloodExplosionSpikyAnimated").active = false;
            this.Owner.getChildByName("GenericDeath").active = false
        }
        SelectTargetNode() {
            let resultObj = null;
            let _vicinityObjNum = 0;
            let test = [];
            if (this.rivalryNode != null) {
                let length = null;
                for (let i = 0; i < this.rivalryNode.numChildren; i++) {
                    let Obj = this.rivalryNode.getChildAt(i);
                    if (Obj.destroyed == false && Obj.id != this.Owner.id && Obj.getComponent(ObjCom) != null) {
                        let length_temp = Laya.Vector3.distance(this.Owner.transform.position, Obj.transform.position);
                        if (length_temp < this.volume) {
                            _vicinityObjNum += Obj.getComponent(ObjCom).volume
                        }
                        if (length != null) {
                            if (length > length_temp) {
                                resultObj = Obj;
                                length = length_temp
                            }
                        } else {
                            length = length_temp;
                            resultObj = Obj
                        }
                    }
                }
            }
            this.targetNode = resultObj;
            if (this.targetNode != null) {}
            if (_vicinityObjNum > this.volume + this.stopVolume) {
                this.stopVolume += 0.1
            } else if (_vicinityObjNum < this.volume + this.stopVolume) {
                if (this.stopVolume - 0.1 >= 0) this.stopVolume -= 0.1
            }
        }
        onUpdate() {
            this.SelectTargetNode();
            this.RunMove()
        }
        RunMove() {
            if (this.AnimName != "Jab Cross" && this.AnimName != "Standing Melee Attack Downward") {
                this.Rig3D.wakeUp();
                if (this.isRun && this.targetNode != null && this.targetNode.destroyed == false) {
                    this.targetPos.setValue(this.targetNode.transform.position.x, 0, this.targetNode.transform.position.z);
                    Laya.Vector3.subtract(this.targetPos, this.Owner.transform.position, this.inputPos);
                    let distance = Laya.Vector3.scalarLength(this.inputPos);
                    if (distance > this.volume + this.stopVolume) {
                        this.SetAnim("Unarmed Run Forward");
                        Laya.Vector3.normalize(this.inputPos, this.inputPos);
                        this.forceObj.setValue(this.inputPos.x * Laya.timer.delta * this.maxForce, this.inputPos.y * Laya.timer.delta * this.maxForce, this.inputPos.z * Laya.timer.delta * this.maxForce);
                        let body = this.Owner.getChildByName("body");
                        body.transform.lookAt(this.targetPos, new Laya.Vector3(0, 1, 0));
                        this.Owner.transform.translate(this.forceObj)
                    } else if (this.AnimName != "Jab Cross" && this.AnimName != "Standing Melee Attack Downward") {
                        if (this.Owner.getComponent(ObjRoleCom).levelNum == 0) {
                            this.SetAnim("Jab Cross", 0.1)
                        } else {
                            this.SetAnim("Standing Melee Attack Downward", 0.1)
                        }
                        let targetNode = this.targetNode;
                        Laya.timer.once((1000 / 30) * 15 + Tools_Plant.Random(1, 2), this, () => {
                            if (this.Owner.destroyed == false && targetNode != null && targetNode.destroyed == false) {
                                let ObjC = targetNode.getComponent(ObjCom);
                                if (ObjC) {
                                    ObjC.BeingHurt(targetNode)
                                }
                            }
                            Laya.timer.once(1000, this, () => {
                                this.SetAnim("Idle", 1)
                            })
                        })
                    }
                } else {
                    if (this.AnimName == "Unarmed Run Forward") this.SetAnim("Idle")
                }
            }
        }
        SetAnim(animName, transitionDuration = 0.01) {
            if (animName != this.AnimName) {
                this.AnimName = animName;
                this.Anim.crossFade(animName, transitionDuration);
                this.AnimSkin.crossFade(animName, transitionDuration)
            }
        }
        BeingHurt(targetNode) {
            if (this.targetNode == null) return;
            let attackObjRoleC = this.targetNode.getComponent(ObjRoleCom);
            if (attackObjRoleC == null) return;
            let ObjRoleC = this.Owner.getComponent(ObjRoleCom);
            if (this.Owner.name != "Dummy") {
                SoundManager.play(SoundManager.SoundConfig.attack);
                if (ObjRoleC.curBlood - attackObjRoleC.AttackCur <= 0) {
                    ObjRoleC.curBlood = 0
                } else {
                    ObjRoleC.curBlood -= attackObjRoleC.AttackCur
                }
                if (ObjRoleC.curBlood == 0) {
                    this.Die()
                } else {
                    this.Owner.getChildByName("BloodExplosionSpikyAnimated").active = false
                }
            }
        }
        Die() {
            GameControl.I.Obj_Die.addChild(this.Owner);
            let ObjRoleC = this.Owner.getComponent(ObjRoleCom);
            let ObjRigC = this.Owner.getComponent(Laya.Rigidbody3D);
            ObjRigC.enabled = false;
            GameControl.I.Obj_Die.addChild(this.Owner);
            this.Owner.getChildByName("GenericDeath").active = false;
            this.Owner.getChildByName("body").active = false;
            Laya.timer.once(1000, this, () => {
                this.Owner.destroy()
            });
            this.destroy();
            GameControl.I.CheckResult()
        }
    }
    var Scene3DManager = new(class Scene3DManager {
        constructor() {
            this.scene3D = null;
            this.directionalLight = null;
            this.place = null
        }
        Init(cb = null) {
            let Path = [ResPath["Scene3D.ls"], ResPath["Directional_Light.lh"], ResPath["blue_Imprint.lh"], ResPath["Enemy_Imprint.lh"], ResPath["Obj_1.lh"], ResPath["Placed.lh"], ResPath["Level" + LocalData.CurLevelNum + ".lh"], ];
            if (LocalData.CurLevelNum == 5) {
                Path.push(ResPath["Map_2.lh"]);
                Path.push(ResPath["Obj_2.lh"])
            } else if (LocalData.CurLevelNum == 10) {
                Path.push(ResPath["Map_3.lh"]);
                Path.push(ResPath["Obj_2.lh"])
            } else {
                Path.push(ResPath["Map_1.lh"])
            }
            console.log(Path);
            Laya.loader.create(Path, Laya.Handler.create(this, () => {
                this.directionalLight = ResGet["Directional_Light.lh"];
                this.scene3D = ResGet["Scene3D.ls"];
                Laya.stage.addChild(this.scene3D);
                this.scene3D.addChildren(this.directionalLight);
                this.scene3D.zOrder = -1;
                this.scene3D.addComponent(GameControl);
                if (cb) cb.run()
            }));
            Laya.timer.once(5000, this, () => {
                Laya.loader.create([ResPath["Map_1.lh"], ResPath["Map_2.lh"], ResPath["Map_3.lh"], ResPath["Obj_2.lh"], ResPath["Obj_1.lh"], ResPath["Level1.lh"], ResPath["Level2.lh"], ResPath["Level3.lh"], ResPath["Level4.lh"], ResPath["Level5.lh"], ResPath["Level6.lh"], ResPath["Level7.lh"], ResPath["Level8.lh"], ResPath["Level9.lh"], ResPath["Level10.lh"], ])
            })
        }
        CloseHDR(Camera) {
            Camera.enableHDR = false
        }
        OpenShadow(DirectionLight) {
            DirectionLight.shadowMode = Laya.ShadowMode.SoftHigh;
            DirectionLight.shadowDistance = 100;
            DirectionLight.shadowResolution = 2048;
            DirectionLight.shadowCascadesMode = Laya.ShadowCascadesMode.NoCascades;
            DirectionLight.shadowStrength = 0.5
        }
        OpenFog(Scene3D, MainCamera) {
            Scene3D.enableFog = true;
            Scene3D.fogColor = new Laya.Vector3(1, 1, 1);
            Scene3D.fogStart = 100;
            Scene3D.fogRange = 150
        }
        RecoveryGPU() {
            Laya.timer.once(1000, this, () => {
                console.log("【回收GPU】");
                Laya.Resource.destroyUnusedResources()
            })
        }
    })();
    class ObjPlaced extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.Owner = null;
            this.Rig3D = null;
            this.Anim = null;
            this.AnimSkin = null;
            this.isDrop = false;
            this.isRun = false
        }
        onStart() {
            this.Owner = this.owner;
            this.Rig3D = this.Owner.getComponent(Laya.Rigidbody3D);
            this.Anim = this.Owner.getChildAt(0).getChildAt(0).getComponent(Laya.Animator);
            this.AnimSkin = this.Owner.getChildAt(0).getChildAt(1).getComponent(Laya.Animator);
            this.isDrop = false;
            this.Drop()
        }
        Drop() {
            this.isDrop = true;
            this.Rig3D.enabled = true;
            this.Rig3D.linearDamping = 0.99;
            this.Rig3D.sleepLinearVelocity = 0.1;
            this.Anim.crossFade("Falling", 0.3);
            this.AnimSkin.crossFade("Falling", 0.3)
        }
        onUpdate() {
            this.RunDrop()
        }
        RunDrop() {
            if (this.isDrop) {
                if (this.Owner.transform.localPositionY - 8 * (Laya.timer.delta / 1000) > 0) {
                    this.Owner.transform.localPositionY -= 8 * (Laya.timer.delta / 1000)
                } else {
                    this.Owner.transform.localPositionY = 0;
                    this.Anim.crossFade("Idle", 0.05);
                    this.AnimSkin.crossFade("Idle", 0.05);
                    Laya.timer.once(300, this, () => {
                        let ObjCom_I = this.Owner.addComponent(ObjCom);
                        ObjCom_I.rivalryNode = GameControl.I.Obj_Enemy;
                        ObjCom_I.isRun = true;
                        this.destroy()
                    })
                }
            }
        }
        onTriggerEnter(other) {
            switch (other.owner.name) {
                case "Door":
                    var Owner = other.owner;
                    Owner.getChildByName("pass").active = false;
                    Owner.getChildByName("pass").active = true;
                    break
            }
        }
        onTriggerExit(other) {
            switch (other.owner.parent.name) {
                case "Door_x2":
                    this.Door_x2();
                    SoundManager.Shake();
                    break;
                case "Door_x3":
                    this.Door_x3();
                    SoundManager.Shake();
                    break;
                case "Door_upgrade":
                    this.Door_upgrade();
                    SoundManager.Shake();
                    break;
                case "Door_purple":
                    this.Door_purple();
                    SoundManager.Shake();
                    break
            }
        }
        Door_x2() {
            for (let i = 0; i < 2; i++) {
                let closeObj = this.Owner.clone();
                let ObjRoleC = closeObj.getComponent(ObjRoleCom);
                let curObjRoleC = this.Owner.getComponent(ObjRoleCom);
                ObjRoleC.isPlayer = curObjRoleC.isPlayer;
                ObjRoleC.levelNum = curObjRoleC.levelNum;
                this.Owner.parent.addChild(closeObj)
            }
        }
        Door_x3() {
            for (let i = 0; i < 3; i++) {
                let closeObj = this.Owner.clone();
                let ObjRoleC = closeObj.getComponent(ObjRoleCom);
                let curObjRoleC = this.Owner.getComponent(ObjRoleCom);
                ObjRoleC.isPlayer = curObjRoleC.isPlayer;
                ObjRoleC.levelNum = curObjRoleC.levelNum;
                this.Owner.parent.addChild(closeObj)
            }
        }
        Door_upgrade() {
            let ObjRoleC = this.Owner.getComponent(ObjRoleCom);
            if (ObjRoleC.levelNum + 1 <= 6) {
                ObjRoleC.levelNum += 1;
                ObjRoleC.upDateDisplay()
            }
        }
        Door_purple() {
            console.log();
            let RandomNum = Tools_Plant.Random(1, 3);
            if (RandomNum == 1) {
                this.Door_x2()
            } else if (RandomNum == 2) {
                this.Door_x3()
            } else if (RandomNum == 3) {
                this.Door_upgrade()
            }
        }
    }
    class PlacedCom extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.Owner = null;
            this.CurPos = new Laya.Vector3();
            this.eventX = null;
            this.eventY = null
        }
        onStart() {
            this.Owner = this.owner;
            this.Init();
            this.RessetPos();
            this.AddObjHand();
            this.GuideShow(false);
            EventControl$1.on(EventName.EnterLevel, this, this.EnterLevel);
            EventControl$1.on(EventName.ResetLevel, this, this.ResetLevel);
            EventControl$1.on(EventName.RefreshObj, this, this.RefreshObj);
            this.StartPos = this.Owner.getChildByName("StartPos");
            this.EndPos = this.Owner.getChildByName("EndPos");
            this.Line = this.Owner.getChildByName("Line");
            Laya.timer.frameLoop(2, this, () => {
                this.CreateHit()
            })
        }
        EnterLevel() {
            this.GuideShow(true);
            GameControl.I.AddDummy()
        }
        ResetLevel() {
            this.RessetPos();
            this.GuideShow(false);
            let Anim = Tools_Game3D.Find("Hand/HandAnim", this.Owner).getComponent(Laya.Animator);
            Anim.crossFade("NewHand_Holding", 0.25);
            Laya.timer.once(200, this, () => {
                this.AddObjHand();
                this.GuideShow(false)
            })
        }
        RefreshObj() {
            this.AddObjHand()
        }
        Init() {
            Tools_Game3D.Find("EndPos/Stickman_Enemy/mixamorig:Hips", this.Owner).active = false;
            Tools_Game3D.Find("Hand/HandAnim/Graphic/NewHand/HandRig", this.Owner).active = false
        }
        RessetPos() {
            this.Owner.transform.position = new Laya.Vector3(0, 0, 0);
            this.CurPos.setValue(this.Owner.transform.position.x, this.Owner.transform.position.y, this.Owner.transform.position.z)
        }
        GuideShow(isShow = true) {
            if (isShow) {
                Tools_Game3D.Find("Line", this.Owner).active = true;
                Tools_Game3D.Find("EndPos", this.Owner).active = true
            } else {
                Tools_Game3D.Find("Line", this.Owner).active = false;
                Tools_Game3D.Find("EndPos", this.Owner).active = false
            }
        }
        AddObjHand() {
            this.GuideShow(true);
            let CloseObj = ResGet["Obj_1.lh"].clone();
            let ObjRoleC = CloseObj.addComponent(ObjRoleCom);
            ObjRoleC.isPlayer = true;
            ObjRoleC.levelNum = LocalData.RoleLevelNum;
            let StartPos = this.Owner.getChildByName("StartPos");
            StartPos.destroyChildren();
            CloseObj.transform.localPosition = new Laya.Vector3();
            CloseObj.transform.localRotationEuler = new Laya.Vector3();
            CloseObj.getComponent(Laya.Rigidbody3D).enabled = false;
            StartPos.addChild(CloseObj);
            CloseObj.getChildByName("body").getChildByName("Anim").getComponent(Laya.Animator).play("daiji");
            CloseObj.getChildByName("body").getChildByName("Obj_Skin").getComponent(Laya.Animator).play("daiji")
        }
        LoosenHand() {
            this.isDown = false;
            this.eventX = null;
            this.eventY = null;
            let Obj = this.Owner.getChildByName("StartPos").getChildAt(0);
            if (Obj != null) {
                SoundManager.play(SoundManager.SoundConfig.drop);
                this.GuideShow(false);
                GameControl.I.usableNum -= 1;
                Tools_Game3D.add3DChild(GameControl.I.Obj_Player, Obj);
                Obj.addComponent(ObjPlaced);
                let Anim = Tools_Game3D.Find("Hand/HandAnim", this.Owner).getComponent(Laya.Animator);
                Anim.crossFade("NewHand_Relesing", 0);
                Laya.timer.once((1000 / 30) * 13, this, () => {
                    Anim.crossFade("NewHand_idel", 1);
                    Laya.timer.once((1000 / 30) * 30, this, () => {
                        if (GameControl.I.usableNum > 0) {
                            Anim.crossFade("NewHand_Holding", 0.25);
                            Laya.timer.once(200, this, () => {
                                this.AddObjHand();
                                Laya.timer.once(1000, this, () => {
                                    GameControl.I.RemoveDummy()
                                })
                            })
                        }
                    })
                })
            }
        }
        Down(event) {
            this.isDown = true;
        }
        Move(event) {
            if (this.isDown && this.eventX != null && this.eventY != null) {
                this.CurPos.x -= (event.stageX - this.eventX) * 0.02;
                if (LocalData.CurLevelNum % 5 == 0) {
                    this.CurPos.z -= (event.stageY - this.eventY) * 0.02
                }
                if (this.CurPos.x < -3) {
                    this.CurPos.x = -3
                }
                if (this.CurPos.x > 3) {
                    this.CurPos.x = 3
                }
                if (this.CurPos.z < -10) {
                    this.CurPos.z = -10
                }
                if (this.CurPos.z > 0) {
                    this.CurPos.z = 0
                }
            } else {
                this.CurPos.setValue(this.Owner.transform.position.x, 0, this.Owner.transform.position.z)
            }
            this.eventX = event.stageX;
            this.eventY = event.stageY
        }
        onUpdate() {
            Laya.Vector3.lerp(this.Owner.transform.position, this.CurPos, 0.5, this.Owner.transform.position);
            this.Owner.transform.position = this.Owner.transform.position
        }
        CreateHit() {
            var hitResult = new Laya.HitResult();
            var hitResults = [];
            let num = 0;
            Scene3DManager.scene3D.physicsSimulation.raycastAllFromTo(this.StartPos.transform.position, this.EndPos.transform.position, hitResults);
            for (let i = 0, n = hitResults.length; i < n; i++) {
                let itemname = hitResults[i].collider.owner.name;
                if (itemname == "Door") {
                    num++
                }
                if (num > 2) {
                    console.log("穿过两个环");
                    for (let i = 0; i < this.Line.numChildren; i++) {
                        this.mesh = this.Line.getChildAt(i);
                        this.material = this.mesh.meshRenderer.material;
                        this.material.albedoColor = new Laya.Vector4(195 / 255, 175 / 255, 69 / 255, 1)
                    }
                } else {
                    for (let i = 0; i < this.Line.numChildren; i++) {
                        this.mesh = this.Line.getChildAt(i);
                        this.material = this.mesh.meshRenderer.material;
                        this.material.albedoColor = new Laya.Vector4(1, 1, 1, 1)
                    }
                }
            }
        }
    }
    class GameControl extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.PlacedC = null;
            this.Scene3D = null;
            this.Obj_Player = null;
            this.Obj_Enemy = null;
            this.Obj_Die = null;
            this.usableNum = 0;
            this.CurLevel = null
        }
        onStart() {
            nativeOpen("游戏主页",1)
            GameControl.I = this;
            this.AddEnevt();
            EventControl$1.emit(EventName.LaunchGame)
        }
        LaunchGame() {
            this.Scene3D = this.owner;
            this.Scene3D.zOrder = -1;
            this.Obj_Player = new Laya.Sprite3D("Obj_Player");
            this.Obj_Enemy = new Laya.Sprite3D("Obj_Enemy");
            this.Obj_Die = new Laya.Sprite3D("Obj_Die");
            this.Scene3D.addChild(this.Obj_Player);
            this.Scene3D.addChild(this.Obj_Enemy);
            this.Scene3D.addChild(this.Obj_Die);
            let Placed = ResGet["Placed.lh"];
            this.PlacedC = Placed.addComponent(PlacedCom);
            this.Scene3D.addChild(Placed);
            this.InitLevel()
        }
        InitLevel() {
            this.CurLevel = ResGet["Level" + LocalData.CurLevelNum + ".lh"].clone();
            this.Scene3D.addChild(this.CurLevel);
            if (LocalData.CurLevelNum == 5) {
                this.Scene3D.addChild(ResGet["Map_2.lh"]);
                this.Scene3D.removeChild(ResGet["Map_1.lh"]);
                this.Scene3D.removeChild(ResGet["Map_3.lh"])
            } else if (LocalData.CurLevelNum == 10) {
                this.Scene3D.addChild(ResGet["Map_3.lh"]);
                this.Scene3D.removeChild(ResGet["Map_1.lh"]);
                this.Scene3D.removeChild(ResGet["Map_2.lh"])
            } else {
                this.Scene3D.addChild(ResGet["Map_1.lh"]);
                this.Scene3D.removeChild(ResGet["Map_2.lh"]);
                this.Scene3D.removeChild(ResGet["Map_3.lh"])
            }
            let EnemyBox = this.CurLevel.getChildByName("EnemyBox");
            let DoorBox = this.CurLevel.getChildByName("DoorBox");
            for (let i = 0; i < DoorBox.numChildren; i++) {
                DoorBox.getChildAt(i).getChildByName("Door").addComponent(DoorCom)
            }
            for (let i = 0; i < EnemyBox.numChildren; i++) {
                let follow = EnemyBox.getChildAt(i);
                let Obj = null;
                let levelnum = Number(follow.name.split("level")[1]);
                if (levelnum == 6) {
                    Obj = ResGet["Obj_2.lh"].clone()
                } else {
                    Obj = ResGet["Obj_1.lh"].clone()
                }
                let ObjRoleC = Obj.addComponent(ObjRoleCom);
                ObjRoleC.isPlayer = false;
                ObjRoleC.levelNum = levelnum;
                let ObjC = Obj.addComponent(ObjCom);
                ObjC.rivalryNode = GameControl.I.Obj_Player;
                ObjC.isRun = true;
                Obj.name = follow.name + i;
                this.Obj_Enemy.addChild(Obj);
                Obj.transform.position = follow.transform.position;
                Obj.transform.rotationEuler = new Laya.Vector3()
            }
            this.usableNum = LocalData.MaxObjNum
        }
        AddEnevt() {
            EventControl$1.once(EventName.LaunchGame, this, () => {
                this.LaunchGame();
                UIControl.ShowUI(View_Main)
            })
        }
        AddDummy() {
            let DummyBox = this.CurLevel.getChildByName("DummyBox");
            for (let i = 0; i < DummyBox.numChildren; i++) {
                let posNode = DummyBox.getChildAt(i);
                let CloseObj = ResGet["Obj_1.lh"].clone();
                CloseObj.getChildAt(0).active = false;
                let Rig3D = CloseObj.getComponent(Laya.Rigidbody3D);
                Rig3D.isTrigger = true;
                CloseObj.name = "Dummy";
                this.Obj_Player.addChild(CloseObj);
                CloseObj.transform.position = posNode.transform.position;
                CloseObj.addComponent(ObjCom)
            }
        }
        RemoveDummy() {
            for (let i = this.Obj_Player.numChildren - 1; i >= 0; i--) {
                let objPlayer = this.Obj_Player.getChildAt(i);
                if (objPlayer.name == "Dummy") {
                    console.log("删除假人");
                    objPlayer.destroy()
                }
            }
        }
        CheckResult() {
            if (this.usableNum == 0 && this.Obj_Player.numChildren == 0) {
                Laya.timer.once(1000, this, () => {
                    UIControl.RemoveUI(View_Game);
                    UIControl.ShowUI(View_OverErr)
                })
            } else if (this.Obj_Enemy.numChildren == 0) {
                Laya.timer.once(1000, this, () => {
                    UIControl.RemoveUI(View_Game);
                    UIControl.ShowUI(View_OverWin)
                })
            }
        }
        ClearLevel() {
            if (this.CurLevel != null) {
                this.CurLevel.destroy()
            }
            this.Obj_Player.destroyChildren();
            this.Obj_Enemy.destroyChildren();
            this.Obj_Die.destroyChildren()
        }
        RessetLevel() {
            this.ClearLevel();
            this.InitLevel();
            EventControl$1.emit(EventName.ResetLevel)
        }
    }
    GameControl.I = null;
    class View_Sign extends ui.ViewSign.View_SignUI {
        onAwake() {
            nativeOpen("每日奖励页",1)
            Tools_UI.AnimationUI_BtnScale(this.sign_btn);
            Tools_UI.AnimationUI_Show(this.main, 5, 500);
            this.UpPageData();
            if (View_Sign.IsSign()) {
                this.sign_btn.visible = false
            } else {
                this.sign_btn.visible = true
            }
            this.sign_btn.on(Laya.Event.CLICK, this, this.ClickSign, [false]);
            let isSignCloseFirst = false;
            this.sign_close.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                UIControl.ShowUI(View_Main);
                UIControl.RemoveUI(View_Sign)
            })
        }
        onEnable() {}
        GetAward(day_num) {
            let info_text_arr = ["+ 2 0 0 0", "+ 2 5 0 0", "+ 3 0 0 0", "+ 4 0 0 0", "+ 5 0 0 0", "+ 6 0 0 0", "+ 8 0 0 0", "+ 4 0 0 0", "+ 5 0 0 0", "+ 6 0 0 0", "+ 7 0 0 0", "+ 8 0 0 0", "+ 1 0 0 0 0", "+ 1 2 0 0 0", ];
            let info_text_ratio = LocalData.SingCount > 7 ? 2 : 1;
            return info_text_arr[(day_num - 1) * info_text_ratio]
        }
        UpPageData() {
            if (View_Sign.IsSign()) {
                this.sign_btn.visible = false
            } else {
                this.sign_btn.visible = true
            }
            let DayNum = this.IsDay();
            for (let item_index = 0; item_index < 7; item_index++) {
                let sign_item = this.SignBox.getChildAt(item_index);
                let tip = sign_item.getChildByName("tip");
                let day_num = sign_item.getChildByName("day_num");
                let info_text = sign_item.getChildByName("info_text");
                let img_icon = sign_item.getChildByName("img_icon");
                if (tip) tip.visible = false;
                if (day_num) day_num.visible = false;
                if (info_text) info_text.visible = false;
                if (img_icon) img_icon.visible = false;
                if (!View_Sign.IsSign() && DayNum == item_index + 1) {
                    if (tip) tip.visible = true
                }
                if (img_icon) img_icon.visible = true;
                if (info_text) info_text.visible = true;
                if (day_num) day_num.visible = true;
                day_num.text = window.isRussian ? `День ${item_index+1}` : `第 ${item_index+1} 天`;
                info_text.text = this.GetAward(item_index + 1)
            }
        }
        ClickSign(is_double) {
            SoundManager.play(SoundManager.SoundConfig.btn);
            if (View_Sign.IsSign()) {
                Tools_UI.Tip(window.isRussian ? "Вошел" : "Signed-in")
            } else {
                LocalData.SingTime = Math.floor(Date.now() / 86400000);
                LocalData.SingCount += 1;
                this.GiveAward(is_double);
                this.UpPageData()
            }
        }
        GiveAward(is_double) {
            let award_string = this.GetAward(this.IsDay());
            let result = null;
            console.log(award_string, is_double);
            if (award_string == "+ 2 0 0 0") {
                result = 2000
            } else if (award_string == "+ 3 0 0 0") {
                result = 3000
            } else if (award_string == "+ 4 0 0 0") {
                result = 4000
            } else if (award_string == "+ 5 0 0 0") {
                result = 5000
            } else if (award_string == "+ 6 0 0 0") {
                result = 6000
            } else if (award_string == "+ 7 0 0 0") {
                result = 7000
            } else if (award_string == "+ 8 0 0 0") {
                result = 8000
            } else if (award_string == "+ 1 0 0 0 0") {
                result = 10000
            } else if (award_string == "+ 1 2 0 0 0") {
                result = 12000
            } else if (award_string == "终 极 奖 励") {
                result = "终极奖励"
            } else if (award_string == "特 殊 奖 励") {
                result = "特殊奖励"
            }
            if (typeof result == "number") {
                if (is_double) result *= 2;
                LocalData.CurCoinNum += result;
                Tools_UI.Tip(window.isRussian ? "Получил " + result + " монет" : "获得 " + result + " 金币");
            } else {
                if (result == "特殊奖励") {
                    let data = LocalData["StoreData_" + 1][12 - 1];
                    data.isBuy = true;
                    LocalData["StoreData_" + 1] = LocalData["StoreData_" + 1];
                    Tools_UI.Tip(window.isRussian ? "Получите награды за скины" : "获得新皮肤")
                }
                if (result == "终极奖励") {
                    let data = LocalData["StoreData_" + 1][29 - 1];
                    data.isBuy = true;
                    LocalData["StoreData_" + 1] = LocalData["StoreData_" + 1];
                    Tools_UI.Tip(window.isRussian ? "Получите награды за скины" : "获得新皮肤")
                }
            }
        }
        static IsSign() {
            let CurTime = Math.floor(Date.now() / 86400000);
            if (LocalData.SingTime == CurTime) {
                return true
            } else {
                return false
            }
        }
        IsDay() {
            let day = LocalData.SingCount % 7;
            if (View_Sign.IsSign()) day = (LocalData.SingCount - 1) % 7;
            day = day == 0 ? 7 : day;
            return day
        }
    }
    View_Sign.NAME = "View_Sign";
    View_Sign.AUTO = true;
    View_Sign.DATA = null;
    View_Sign.isSignFirst = false;
    class View_Loading extends ui.View_LoadingUI {
        onAwake() {}
    }
    View_Loading.NAME = "View_Loading";
    View_Loading.AUTO = true;
    View_Loading.DATA = null;
    class View_Store extends ui.View_StoreUI {
        constructor() {
            super(...arguments);
            this.selectIndex = 0
        }
        onAwake() {
            this.selectIndex = LocalData.UseSkin - 1;
            this.UpDateDisplay();
            this.ListPanel.on(Laya.Event.CLICK, this, this.OnSelect);
            this.btn_use.on(Laya.Event.CLICK, this, this.OnBtnUse);
            this.btn_getCoin.on(Laya.Event.CLICK, this, this.OnGetCoin);
            this.btn_close.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                EventControl$1.emit(EventName.RefreshObj);
                UIControl.ShowUI(View_Main);
                UIControl.RemoveUI(View_Store)
            });
            Laya.timer.frameLoop(1, this, () => {
                this.coin_num.text = LocalData.CurCoinNum + ""
            })
        }
        OnSelect(event) {
            if (event.target.name.indexOf("skin_") == 0) {
                SoundManager.play(SoundManager.SoundConfig.btn);
                this.selectIndex = Number(event.target.name.split("skin_")[1]) - 1;
                this.UpDateDisplay(true)
            }
        }
        OnBtnUse() {
            SoundManager.play(SoundManager.SoundConfig.btn);
            if (this.btn_use.alpha == 0.5) {
                LocalData.UseSkin = 0
            } else {
                LocalData.UseSkin = this.selectIndex + 1
            }
            this.UpDateDisplay()
        }
        OnGetCoin() {
            SoundManager.play(SoundManager.SoundConfig.btn);
            playVideo(res => {
                if (res) {
                    LocalData.CurCoinNum += 1000;
                    console.log("get coin");
                    Tools_UI.Tip(window.isRussian ? "Получил 1000 монет" : "获得 1000 金币")
                } else {}
            },1001)
        }
        UpDateDisplay(isBuy = false) {
            nativeOpen("商店页",1)
            let CoinData = [1000, 2000, 3000, 4000, 5000, 6000, 7000, 8000, 9000];
            this.ListPanel.vScrollBar.hide = true;
            let NoHaveIndex = [];
            LocalData.AllSkin.forEach((item, index) => {
                if (LocalData.HaveSkin.indexOf(item) == -1) {
                    NoHaveIndex.push(index)
                }
            });
            for (let i = 0; i < 9; i++) {
                let SkinItem = this.ListPanel.getChildAt(i);
                let bg_have = SkinItem.getChildByName("bg_have");
                let img_skin = SkinItem.getChildByName("img_skin");
                let bg_lock = SkinItem.getChildByName("bg_lock");
                let bg_select = SkinItem.getChildByName("bg_select");
                let bg_text = SkinItem.getChildByName("bg_text");
                let text_use = SkinItem.getChildByName("text_use");
                let text_have = SkinItem.getChildByName("text_have");
                let text_coin = SkinItem.getChildByName("text_coin");
                bg_lock.visible = false;
                bg_select.visible = false;
                text_use.visible = false;
                text_have.visible = false;
                text_coin.visible = false;
                text_coin.text = CoinData[i] + "";
                if (this.selectIndex == i) {
                    bg_select.visible = true;
                    this.img_show.skin = "skin/skin_" + (i + 1) + ".png"
                }
                if (NoHaveIndex.indexOf(i) > -1) {
                    bg_lock.visible = true;
                    text_coin.visible = true
                } else {
                    if (LocalData.UseSkin == i + 1) {
                        text_use.visible = true
                    } else {
                        text_have.visible = true
                    }
                }
            }
            if (NoHaveIndex.indexOf(this.selectIndex) > -1) {
                this.btn_use.visible = false;
                if (isBuy) {
                    if (LocalData.CurCoinNum - CoinData[this.selectIndex] >= 0) {
                        LocalData.CurCoinNum -= CoinData[this.selectIndex];
                        LocalData.HaveSkin.push(this.selectIndex + 1);
                        LocalData.HaveSkin = LocalData.HaveSkin;
                        this.UpDateDisplay()
                    } else {
                        Tools_UI.Tip(window.isRussian ? "Монет не достаточно" : "金币不足!")
                    }
                }
            } else {
                this.btn_use.visible = true;
                if (LocalData.UseSkin == this.selectIndex + 1) {
                    this.btn_use.mouseEnabled = false;
                    this.btn_use.alpha = 0.5
                } else {
                    this.btn_use.mouseEnabled = true;
                    this.btn_use.alpha = 1
                }
            }
        }
    }
    View_Store.NAME = "View_Store";
    View_Store.AUTO = true;
    View_Store.DATA = null;
    class View_Main extends ui.View_MainUI {
        onAwake() {
            if (LocalData.FirstLogin) {
                UIControl.ShowUI(View_Sign);
                LocalData.FirstLogin = false
            }
            if (View_Main.DATA == 1) {
                UIControl.ShowUI(View_Draw)
            }
            Tools_UI.AnimationUI_BtnScale(this.startBtn, 2);
            Tools_UI.AnimationUI_BtnScale(this.item_1, 2);
            Tools_UI.AnimationUI_BtnScale(this.item_2, 2);
            Tools_UI.AnimationUI_BtnScale(this.item_3, 2);
            UIControl.RemoveUI(View_Launch);
            UIControl.RemoveUI(View_Loading);
            this.startBtn.on(Laya.Event.CLICK, this, this.onClickStart);
            Laya.timer.frameLoop(1, this, () => {
                this.obj_num.text = GameControl.I.usableNum + "";
                this.level_num.text = (window.isRussian ? "Уровень " : "Level ") + LocalData.CurLevelNum + "";
                this.coin_num.text = LocalData.CurCoinNum + ""
            });
            this.upDateItem();
            this.item_1.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                let useCoin = LocalData.RoleLevelNum * 300 + 100;
                let CanUpgrader = LocalData.RoleLevelNum < 6 ? true : false;
                if (CanUpgrader) {
                    if (LocalData.CurCoinNum - useCoin >= 0) {
                        LocalData.CurCoinNum -= useCoin;
                        LocalData.RoleLevelNum += 1;
                        this.upDateItem();
                        EventControl$1.emit(EventName.RefreshObj)
                    } else {
                        Tools_UI.Tip(window.isRussian ? "Монет не достаточно" : "金币不足!")
                    }
                }
            });
            this.item_2.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                let useCoin = (LocalData.MaxObjNum - 3) * 300 + 100;
                let CanUpgrader = LocalData.MaxObjNum - 3 < 6 ? true : false;
                if (CanUpgrader) {
                    if (LocalData.CurCoinNum - useCoin >= 0) {
                        LocalData.CurCoinNum -= useCoin;
                        LocalData.MaxObjNum += 1;
                        GameControl.I.usableNum = LocalData.MaxObjNum;
                        this.upDateItem()
                    } else {
                        Tools_UI.Tip(window.isRussian ? "Монет не достаточно" : "金币不足!")
                    }
                }
            });
            this.item_3.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                let useCoin = LocalData.CoinBonusNum * 300 + 100;
                let CanUpgrader = LocalData.CoinBonusNum < 6 ? true : false;
                if (CanUpgrader) {
                    if (LocalData.CurCoinNum - useCoin >= 0) {
                        LocalData.CurCoinNum -= useCoin;
                        LocalData.CoinBonusNum += 1;
                        this.upDateItem()
                    } else {
                        Tools_UI.Tip(window.isRussian ? "Монет не достаточно" : "金币不足!")
                    }
                }
            });
            this.btn_store.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                UIControl.ShowUI(View_Store);
                UIControl.RemoveUI(View_Main)
            });
            this.btn_sign.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                UIControl.ShowUI(View_Sign);
                UIControl.RemoveUI(View_Main)
            });
            // this.ohayoLogo.on(Laya.Event.CLICK, this, () => {
            //     if (ysdk.environment.i18n.tld == "ru") {
            //         window.open("https://yandex.ru/games/developer?name=Ohayo");
            //     } else {
            //         window.open("https://yandex.com/games/developer?name=Ohayo");
            //     }
            // });
            this.btn_draw.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                UIControl.ShowUI(View_Draw);
                UIControl.RemoveUI(View_Main)
            });
            this.btn_setting.on(Laya.Event.CLICK, this, () => {
                SoundManager.play(SoundManager.SoundConfig.btn);
                UIControl.ShowUI(View_Setting)
            })
        }
        onEnable() {}
        upDateItem() {
            let useCoin_1 = LocalData.RoleLevelNum * 300 + 100;
            let useCoin_2 = (LocalData.MaxObjNum - 3) * 300 + 100;
            let useCoin_3 = LocalData.CoinBonusNum * 300 + 100;
            let CanUpgrader_1 = LocalData.RoleLevelNum < 6 ? true : false;
            let CanUpgrader_2 = LocalData.MaxObjNum - 3 < 6 ? true : false;
            let CanUpgrader_3 = LocalData.CoinBonusNum < 6 ? true : false;
            this.useCoin_1.text = useCoin_1 + "";
            this.useCoin_2.text = useCoin_2 + "";
            this.useCoin_3.text = useCoin_3 + "";
            if (!CanUpgrader_1) this.useCoin_1.text = "MAX";
            if (!CanUpgrader_2) this.useCoin_2.text = "MAX";
            if (!CanUpgrader_3) this.useCoin_3.text = "MAX"
        }
        onClickStart() {
            console.log(View_Main.isFirst, "点击了开始游戏事件");
            SoundManager.play(SoundManager.SoundConfig.btn);
            EventControl$1.emit(EventName.EnterLevel);
            UIControl.ShowUI(View_Game);
            this.CloseUI()
        }
        CloseUI() {
            UIControl.RemoveUI(View_Main)
        }
    }
    View_Main.NAME = "View_Main";
    View_Main.AUTO = true;
    View_Main.DATA = null;
    View_Main.isFirst = false;
    View_Main.isOneGame = true;
    class Engine extends Laya.Script {
        constructor() {
            super(...arguments);
            this.Owner = null
        }
        onEnable() {
            console.log("入口");
            Engine.InitFirstLogin();
            let _this = this;
            // if (Laya.Browser.onQGMiniGame) {
            //     qg.loadSubpackage({
            //         name: "LayaScene3D",
            //         success: function() {
            //             console.log("LayaScene3D 子包加载成功");
            //             _this.Owner = _this.owner;
            //             Scene3DManager.Init();
            //             Laya.timer.once(100, _this, () => {
            //                 SoundManager.init();
            //                 Laya.SoundManager.playMusic("sound/BGM2.mp3", -1);
            //                 UIControl.ShowUI(View_Loading)
            //             })
            //         },
            //         fail: function(err) {
            //             console.info('加载分包 LayaScene3D 失败', err)
            //         }
            //     })
            // } else {
                Laya.timer.frameOnce(2, this, () => {
                    this.Owner = this.owner;
                    Laya.timer.once(1500, this, () => {
                        Scene3DManager.Init();
                        Laya.timer.once(100, this, () => {
                            SoundManager.init();
                            Laya.SoundManager.playMusic("sound/BGM2.mp3", -1);
                            UIControl.ShowUI(View_Loading)
                        })
                    })
                })
            // }
        }
        static InitFirstLogin() {
            if (LocalData.FirstLogin == null) {
                LocalData.FirstLogin = true;
                LocalData.FirstLoginTime = Math.floor(Date.now() / 86400000)
            } else if (LocalData.FirstLoginTime != Math.floor(Date.now() / 86400000)) {
                LocalData.FirstLogin = true;
                LocalData.FirstLoginTime = Math.floor(Date.now() / 86400000)
            } else {
                LocalData.FirstLogin = false
            }
        }
    }
    class GameConfig {
        constructor() {}
        static init() {
            var reg = Laya.ClassUtils.regClass;
            reg("Code/GameCode/Engine.ts", Engine)
        }
    }
    GameConfig.width = 750;
    GameConfig.height = 1334;
    GameConfig.scaleMode = "fixedauto";
    GameConfig.screenMode = "none";
    GameConfig.alignV = "top";
    GameConfig.alignH = "left";
    GameConfig.startScene = "View_Launch.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();
    class Main {
        constructor() {
            Config.useWebGL2 = false;
            if (window["Laya3D"]) Laya3D.init(GameConfig.width, GameConfig.height);
            else Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
            Laya["Physics"] && Laya["Physics"].enable();
            Laya["DebugPanel"] && Laya["DebugPanel"].enable();
            Laya.stage.scaleMode = GameConfig.scaleMode;
            Laya.stage.screenMode = GameConfig.screenMode;
            Laya.stage.alignV = GameConfig.alignV;
            Laya.stage.alignH = GameConfig.alignH;
            Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
            if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true") Laya.enableDebugPanel();
            if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"]) Laya["PhysicsDebugDraw"].enable();
            if (GameConfig.stat) Laya.Stat.show();
            Laya.alertGlobalError(true);
            Laya.SoundManager.useAudioMusic = false;
            this.onVersionLoaded()
        }
        onVersionLoaded() {
            Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded))
        }
        onConfigLoaded() {
            console.log("SDK初始化-1");
            UIControl.ShowUI(View_Launch)
        }
    }
    new Main()
}());